  MEMBER('Eventmgr.clw')

  INCLUDE('ABFILE.INC'),ONCE

  MAP
EVENTBC0:DctInit    PROCEDURE
EVENTBC0:DctKill    PROCEDURE
EVENTBC0:FilesInit  PROCEDURE
  END

Hide:Access:Events   CLASS(FileManager)
Init                   PROCEDURE
BindFields             PROCEDURE(),DERIVED
Kill                   PROCEDURE(),DERIVED
PrimeFields            PROCEDURE(),PROC,DERIVED
ValidateFieldServer    PROCEDURE(UNSIGNED Id,BYTE HandleErrors),BYTE,PROC,DERIVED
                     END


Hide:Relate:Events   CLASS(RelationManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END

Hide:Access:LineItems CLASS(FileManager)
Init                   PROCEDURE
BindFields             PROCEDURE(),DERIVED
Kill                   PROCEDURE(),DERIVED
ValidateFieldServer    PROCEDURE(UNSIGNED Id,BYTE HandleErrors),BYTE,PROC,DERIVED
                     END


Hide:Relate:LineItems CLASS(RelationManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END

Hide:Access:Vendor   CLASS(FileManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END


Hide:Relate:Vendor   CLASS(RelationManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END

Hide:Access:Sponsor  CLASS(FileManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END


Hide:Relate:Sponsor  CLASS(RelationManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END

Hide:Access:Attendees CLASS(FileManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
ValidateFieldServer    PROCEDURE(UNSIGNED Id,BYTE HandleErrors),BYTE,PROC,DERIVED
                     END


Hide:Relate:Attendees CLASS(RelationManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END

Hide:Access:Members  CLASS(FileManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
ValidateFieldServer    PROCEDURE(UNSIGNED Id,BYTE HandleErrors),BYTE,PROC,DERIVED
                     END


Hide:Relate:Members  CLASS(RelationManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END

Hide:Access:VendorType CLASS(FileManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END


Hide:Relate:VendorType CLASS(RelationManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END

Hide:Access:MemberType CLASS(FileManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END


Hide:Relate:MemberType CLASS(RelationManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END

Hide:Access:MPhones  CLASS(FileManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END


Hide:Relate:MPhones  CLASS(RelationManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END

Hide:Access:VPhones  CLASS(FileManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END


Hide:Relate:VPhones  CLASS(RelationManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END

Hide:Access:SPhones  CLASS(FileManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END


Hide:Relate:SPhones  CLASS(RelationManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END

Hide:Access:States   CLASS(FileManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END


Hide:Relate:States   CLASS(RelationManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END

EVENTBC0:DctInit PROCEDURE
  CODE
  Relate:Events &= Hide:Relate:Events
  Relate:LineItems &= Hide:Relate:LineItems
  Relate:Vendor &= Hide:Relate:Vendor
  Relate:Sponsor &= Hide:Relate:Sponsor
  Relate:Attendees &= Hide:Relate:Attendees
  Relate:Members &= Hide:Relate:Members
  Relate:VendorType &= Hide:Relate:VendorType
  Relate:MemberType &= Hide:Relate:MemberType
  Relate:MPhones &= Hide:Relate:MPhones
  Relate:VPhones &= Hide:Relate:VPhones
  Relate:SPhones &= Hide:Relate:SPhones
  Relate:States &= Hide:Relate:States

EVENTBC0:FilesInit PROCEDURE
  CODE
  Hide:Relate:Events.Init
  Hide:Relate:LineItems.Init
  Hide:Relate:Vendor.Init
  Hide:Relate:Sponsor.Init
  Hide:Relate:Attendees.Init
  Hide:Relate:Members.Init
  Hide:Relate:VendorType.Init
  Hide:Relate:MemberType.Init
  Hide:Relate:MPhones.Init
  Hide:Relate:VPhones.Init
  Hide:Relate:SPhones.Init
  Hide:Relate:States.Init


EVENTBC0:DctKill PROCEDURE
  CODE
  Hide:Relate:Events.Kill
  Hide:Relate:LineItems.Kill
  Hide:Relate:Vendor.Kill
  Hide:Relate:Sponsor.Kill
  Hide:Relate:Attendees.Kill
  Hide:Relate:Members.Kill
  Hide:Relate:VendorType.Kill
  Hide:Relate:MemberType.Kill
  Hide:Relate:MPhones.Kill
  Hide:Relate:VPhones.Kill
  Hide:Relate:SPhones.Kill
  Hide:Relate:States.Kill


Hide:Access:Events.Init PROCEDURE
  CODE
  SELF.Init(Events,GlobalErrors)
  SELF.Buffer &= EVE:Record
  SELF.LockRecover = 10
  SELF.AddKey(EVE:KeyNumber,'EVE:KeyNumber',1)
  SELF.AddKey(EVE:KeyDescription,'EVE:KeyDescription',0)
  SELF.AddKey(EVE:KeyDate,'EVE:KeyDate',0)
  SELF.AddKey(EVE:KeySponsor,'EVE:KeySponsor',0)
  Access:Events &= SELF


Hide:Relate:Events.Init PROCEDURE
  CODE
  Hide:Access:Events.Init
  SELF.Init(Access:Events,1)
  DO AddRelations_1

AddRelations_1 ROUTINE
  SELF.AddRelation(Relate:Sponsor)
  SELF.AddRelation(Relate:Attendees,RI:CASCADE,RI:RESTRICT,ATT:KeyEventTableAttendee)
  SELF.AddRelationLink(EVE:Number,ATT:EventNumber)
  SELF.AddRelation(Relate:LineItems,RI:CASCADE,RI:RESTRICT,LIN:KeyEventNumber)
  SELF.AddRelationLink(EVE:Number,LIN:EventNumber)


Hide:Access:Events.BindFields PROCEDURE

  CODE
  PARENT.BindFields
  BIND('EVE:Notes',EVE:Notes)


Hide:Access:Events.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:Events &= NULL


Hide:Access:Events.PrimeFields PROCEDURE

  CODE
  EVE:Date = today()
  EVE:MaxTables = 20
  EVE:SeatsPerTable = 10
  PARENT.PrimeFields


Hide:Access:Events.ValidateFieldServer PROCEDURE(UNSIGNED Id,BYTE HandleErrors)

ReturnValue          BYTE,AUTO

Save:Sponsor4      USHORT,AUTO
  CODE
  ReturnValue = PARENT.ValidateFieldServer(Id,HandleErrors)
  CASE Id
  OF 4
    GlobalErrors.SetField('EVE:Sponsor')
    Save:Sponsor4 = Access:Sponsor.SaveFile()
    SPO:SponsorNumber = EVE:Sponsor
    ReturnValue = Access:Sponsor.TryFetch(SPO:KeySponsorNumber)
    IF ReturnValue <> Level:Benign
      IF HandleErrors
        ReturnValue = GlobalErrors.ThrowMessage(Msg:FieldNotInFile,'Sponsor')
      END
    END
    Access:Sponsor.RestoreFile(Save:Sponsor4)
  END
  RETURN ReturnValue


Hide:Relate:Events.Kill PROCEDURE

  CODE
  Hide:Access:Events.Kill
  PARENT.Kill
  Relate:Events &= NULL


Hide:Access:LineItems.Init PROCEDURE
  CODE
  SELF.Init(LineItems,GlobalErrors)
  SELF.Buffer &= LIN:Record
  SELF.LockRecover = 10
  SELF.AddKey(LIN:KeyLineNumber,'LIN:KeyLineNumber',2)
  SELF.AddKey(LIN:KeyEventNumber,'LIN:KeyEventNumber',0)
  SELF.AddKey(LIN:KeyItemType,'LIN:KeyItemType',0)
  SELF.AddKey(LIN:VendorKey,'LIN:VendorKey',0)
  SELF.AddKey(LIN:KeyTypeCode,'LIN:KeyTypeCode',0)
  Access:LineItems &= SELF


Hide:Relate:LineItems.Init PROCEDURE
  CODE
  Hide:Access:LineItems.Init
  SELF.Init(Access:LineItems,1)
  DO AddRelations_1

AddRelations_1 ROUTINE
  SELF.AddRelation(Relate:VendorType)
  SELF.AddRelation(Relate:Vendor)
  SELF.AddRelation(Relate:Events)


Hide:Access:LineItems.BindFields PROCEDURE

  CODE
  PARENT.BindFields
  BIND('LIN:Notes',LIN:Notes)


Hide:Access:LineItems.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:LineItems &= NULL


Hide:Access:LineItems.ValidateFieldServer PROCEDURE(UNSIGNED Id,BYTE HandleErrors)

ReturnValue          BYTE,AUTO

Save:Events2       USHORT,AUTO
Save:Vendor6       USHORT,AUTO
  CODE
  ReturnValue = PARENT.ValidateFieldServer(Id,HandleErrors)
  CASE Id
  OF 2
    GlobalErrors.SetField('Internal Number')
    Save:Events2 = Access:Events.SaveFile()
    EVE:Number = LIN:EventNumber
    ReturnValue = Access:Events.TryFetch(EVE:KeyNumber)
    IF ReturnValue <> Level:Benign
      IF HandleErrors
        ReturnValue = GlobalErrors.ThrowMessage(Msg:FieldNotInFile,'Events')
      END
    END
    Access:Events.RestoreFile(Save:Events2)
  OF 6
    GlobalErrors.SetField('LIN:Vendor')
    Save:Vendor6 = Access:Vendor.SaveFile()
    VEN:VendorNumber = LIN:Vendor
    ReturnValue = Access:Vendor.TryFetch(VEN:KeyVendorNumber)
    IF ReturnValue <> Level:Benign
      IF HandleErrors
        ReturnValue = GlobalErrors.ThrowMessage(Msg:FieldNotInFile,'Vendor')
      END
    END
    Access:Vendor.RestoreFile(Save:Vendor6)
  END
  RETURN ReturnValue


Hide:Relate:LineItems.Kill PROCEDURE

  CODE
  Hide:Access:LineItems.Kill
  PARENT.Kill
  Relate:LineItems &= NULL


Hide:Access:Vendor.Init PROCEDURE
  CODE
  SELF.Init(Vendor,GlobalErrors)
  SELF.Buffer &= VEN:Record
  SELF.LockRecover = 10
  SELF.AddKey(VEN:KeyVendorNumber,'VEN:KeyVendorNumber',1)
  SELF.AddKey(VEN:KeyZip,'VEN:KeyZip',0)
  SELF.AddKey(VEN:KeyCompanyName,'VEN:KeyCompanyName',0)
  Access:Vendor &= SELF


Hide:Relate:Vendor.Init PROCEDURE
  CODE
  Hide:Access:Vendor.Init
  SELF.Init(Access:Vendor,1)
  DO AddRelations_1

AddRelations_1 ROUTINE
  SELF.AddRelation(Relate:VPhones,RI:CASCADE,RI:RESTRICT,VPH:KeyVendorNumber)
  SELF.AddRelationLink(VEN:VendorNumber,VPH:VendorNumber)
  SELF.AddRelation(Relate:LineItems,RI:CASCADE,RI:RESTRICT,LIN:VendorKey)
  SELF.AddRelationLink(VEN:VendorNumber,LIN:Vendor)


Hide:Access:Vendor.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:Vendor &= NULL


Hide:Relate:Vendor.Kill PROCEDURE

  CODE
  Hide:Access:Vendor.Kill
  PARENT.Kill
  Relate:Vendor &= NULL


Hide:Access:Sponsor.Init PROCEDURE
  CODE
  SELF.Init(Sponsor,GlobalErrors)
  SELF.Buffer &= SPO:Record
  SELF.LockRecover = 10
  SELF.AddKey(SPO:KeySponsorNumber,'SPO:KeySponsorNumber',1)
  SELF.AddKey(SPO:KeyZip,'SPO:KeyZip',0)
  SELF.AddKey(SPO:KeyCompanyName,'SPO:KeyCompanyName',0)
  Access:Sponsor &= SELF


Hide:Relate:Sponsor.Init PROCEDURE
  CODE
  Hide:Access:Sponsor.Init
  SELF.Init(Access:Sponsor,1)
  DO AddRelations_1

AddRelations_1 ROUTINE
  SELF.AddRelation(Relate:SPhones,RI:CASCADE,RI:RESTRICT,SPH:KeySponsorNumber)
  SELF.AddRelationLink(SPO:SponsorNumber,SPH:SponsorNumber)
  SELF.AddRelation(Relate:Events,RI:CASCADE,RI:RESTRICT,EVE:KeySponsor)
  SELF.AddRelationLink(SPO:SponsorNumber,EVE:Sponsor)


Hide:Access:Sponsor.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:Sponsor &= NULL


Hide:Relate:Sponsor.Kill PROCEDURE

  CODE
  Hide:Access:Sponsor.Kill
  PARENT.Kill
  Relate:Sponsor &= NULL


Hide:Access:Attendees.Init PROCEDURE
  CODE
  SELF.Init(Attendees,GlobalErrors)
  SELF.Buffer &= ATT:Record
  SELF.LockRecover = 10
  SELF.AddKey(ATT:KeyEventTableAttendee,'ATT:KeyEventTableAttendee',0)
  SELF.AddKey(ATT:KeyAttendees,'ATT:KeyAttendees',0)
  SELF.AddKey(ATT:KeyEventAttendee,'ATT:KeyEventAttendee',0)
  Access:Attendees &= SELF


Hide:Relate:Attendees.Init PROCEDURE
  CODE
  Hide:Access:Attendees.Init
  SELF.Init(Access:Attendees,1)
  DO AddRelations_1

AddRelations_1 ROUTINE
  SELF.AddRelation(Relate:Members)
  SELF.AddRelation(Relate:Events)


Hide:Access:Attendees.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:Attendees &= NULL


Hide:Access:Attendees.ValidateFieldServer PROCEDURE(UNSIGNED Id,BYTE HandleErrors)

ReturnValue          BYTE,AUTO

Save:Members3      USHORT,AUTO
  CODE
  ReturnValue = PARENT.ValidateFieldServer(Id,HandleErrors)
  CASE Id
  OF 3
    GlobalErrors.SetField('ATT:Attendee')
    Save:Members3 = Access:Members.SaveFile()
    MEM:MemberNumber = ATT:Attendee
    ReturnValue = Access:Members.TryFetch(MEM:MemberNumberKey)
    IF ReturnValue <> Level:Benign
      IF HandleErrors
        ReturnValue = GlobalErrors.ThrowMessage(Msg:FieldNotInFile,'Members')
      END
    END
    Access:Members.RestoreFile(Save:Members3)
  END
  RETURN ReturnValue


Hide:Relate:Attendees.Kill PROCEDURE

  CODE
  Hide:Access:Attendees.Kill
  PARENT.Kill
  Relate:Attendees &= NULL


Hide:Access:Members.Init PROCEDURE
  CODE
  SELF.Init(Members,GlobalErrors)
  SELF.Buffer &= MEM:Record
  SELF.LockRecover = 10
  SELF.AddKey(MEM:MemberNumberKey,'MEM:MemberNumberKey',1)
  SELF.AddKey(MEM:NameKey,'MEM:NameKey',0)
  SELF.AddKey(MEM:ZipCodeKey,'MEM:ZipCodeKey',0)
  Access:Members &= SELF


Hide:Relate:Members.Init PROCEDURE
  CODE
  Hide:Access:Members.Init
  SELF.Init(Access:Members,1)
  DO AddRelations_1

AddRelations_1 ROUTINE
  SELF.AddRelation(Relate:MemberType,RI:None,RI:None,MTY:KeyTypeCode)
  SELF.AddRelationLink(MEM:MemberType,MTY:TypeCode)
  SELF.AddRelation(Relate:States,RI:None,RI:None,ST:StateKey)
  SELF.AddRelationLink(MEM:State,ST:StateCode)
  SELF.AddRelation(Relate:MPhones,RI:CASCADE,RI:RESTRICT,MPH:KeyMemberNumber)
  SELF.AddRelationLink(MEM:MemberNumber,MPH:MemberNumber)
  SELF.AddRelation(Relate:Attendees,RI:CASCADE,RI:RESTRICT,ATT:KeyAttendees)
  SELF.AddRelationLink(MEM:MemberNumber,ATT:Attendee)


Hide:Access:Members.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:Members &= NULL


Hide:Access:Members.ValidateFieldServer PROCEDURE(UNSIGNED Id,BYTE HandleErrors)

ReturnValue          BYTE,AUTO

Save:States8       USHORT,AUTO
Save:MemberType12  USHORT,AUTO
  CODE
  ReturnValue = PARENT.ValidateFieldServer(Id,HandleErrors)
  CASE Id
  OF 8
    GlobalErrors.SetField('MEM:State')
    Save:States8 = Access:States.SaveFile()
    ST:StateCode = MEM:State
    ReturnValue = Access:States.TryFetch(ST:StateKey)
    IF ReturnValue <> Level:Benign
      IF HandleErrors
        ReturnValue = GlobalErrors.ThrowMessage(Msg:FieldNotInFile,'States')
      END
    END
    Access:States.RestoreFile(Save:States8)
  OF 12
    GlobalErrors.SetField('MEM:MemberType')
    Save:MemberType12 = Access:MemberType.SaveFile()
    MTY:TypeCode = MEM:MemberType
    ReturnValue = Access:MemberType.TryFetch(MTY:KeyTypeCode)
    IF ReturnValue <> Level:Benign
      IF HandleErrors
        ReturnValue = GlobalErrors.ThrowMessage(Msg:FieldNotInFile,'MemberType')
      END
    END
    Access:MemberType.RestoreFile(Save:MemberType12)
  END
  RETURN ReturnValue


Hide:Relate:Members.Kill PROCEDURE

  CODE
  Hide:Access:Members.Kill
  PARENT.Kill
  Relate:Members &= NULL


Hide:Access:VendorType.Init PROCEDURE
  CODE
  SELF.Init(VendorType,GlobalErrors)
  SELF.Buffer &= TYP:Record
  SELF.LockRecover = 10
  SELF.AddKey(TYP:KeyTypeCode,'TYP:KeyTypeCode',0)
  Access:VendorType &= SELF


Hide:Relate:VendorType.Init PROCEDURE
  CODE
  Hide:Access:VendorType.Init
  SELF.Init(Access:VendorType,1)
  DO AddRelations_1

AddRelations_1 ROUTINE
  SELF.AddRelation(Relate:LineItems,RI:CASCADE,RI:RESTRICT,LIN:KeyTypeCode)
  SELF.AddRelationLink(TYP:TypeCode,LIN:ItemTypeCode)


Hide:Access:VendorType.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:VendorType &= NULL


Hide:Relate:VendorType.Kill PROCEDURE

  CODE
  Hide:Access:VendorType.Kill
  PARENT.Kill
  Relate:VendorType &= NULL


Hide:Access:MemberType.Init PROCEDURE
  CODE
  SELF.Init(MemberType,GlobalErrors)
  SELF.Buffer &= MTY:Record
  SELF.Create = 1
  SELF.LockRecover = 10
  SELF.AddKey(MTY:KeyTypeCode,'MTY:KeyTypeCode',0)
  Access:MemberType &= SELF


Hide:Relate:MemberType.Init PROCEDURE
  CODE
  Hide:Access:MemberType.Init
  SELF.Init(Access:MemberType,1)
  DO AddRelations_1

AddRelations_1 ROUTINE
  SELF.AddRelation(Relate:Members)


Hide:Access:MemberType.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:MemberType &= NULL


Hide:Relate:MemberType.Kill PROCEDURE

  CODE
  Hide:Access:MemberType.Kill
  PARENT.Kill
  Relate:MemberType &= NULL


Hide:Access:MPhones.Init PROCEDURE
  CODE
  SELF.Init(MPhones,GlobalErrors)
  SELF.Buffer &= MPH:Record
  SELF.LockRecover = 10
  SELF.AddKey(MPH:KeyMemberNumber,'MPH:KeyMemberNumber',0)
  Access:MPhones &= SELF


Hide:Relate:MPhones.Init PROCEDURE
  CODE
  Hide:Access:MPhones.Init
  SELF.Init(Access:MPhones,1)
  DO AddRelations_1

AddRelations_1 ROUTINE
  SELF.AddRelation(Relate:Members)


Hide:Access:MPhones.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:MPhones &= NULL


Hide:Relate:MPhones.Kill PROCEDURE

  CODE
  Hide:Access:MPhones.Kill
  PARENT.Kill
  Relate:MPhones &= NULL


Hide:Access:VPhones.Init PROCEDURE
  CODE
  SELF.Init(VPhones,GlobalErrors)
  SELF.Buffer &= VPH:Record
  SELF.LockRecover = 10
  SELF.AddKey(VPH:KeyVendorNumber,'VPH:KeyVendorNumber',0)
  Access:VPhones &= SELF


Hide:Relate:VPhones.Init PROCEDURE
  CODE
  Hide:Access:VPhones.Init
  SELF.Init(Access:VPhones,1)
  DO AddRelations_1

AddRelations_1 ROUTINE
  SELF.AddRelation(Relate:Vendor)


Hide:Access:VPhones.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:VPhones &= NULL


Hide:Relate:VPhones.Kill PROCEDURE

  CODE
  Hide:Access:VPhones.Kill
  PARENT.Kill
  Relate:VPhones &= NULL


Hide:Access:SPhones.Init PROCEDURE
  CODE
  SELF.Init(SPhones,GlobalErrors)
  SELF.Buffer &= SPH:Record
  SELF.LockRecover = 10
  SELF.AddKey(SPH:KeySponsorNumber,'SPH:KeySponsorNumber',0)
  Access:SPhones &= SELF


Hide:Relate:SPhones.Init PROCEDURE
  CODE
  Hide:Access:SPhones.Init
  SELF.Init(Access:SPhones,1)
  DO AddRelations_1

AddRelations_1 ROUTINE
  SELF.AddRelation(Relate:Sponsor)


Hide:Access:SPhones.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:SPhones &= NULL


Hide:Relate:SPhones.Kill PROCEDURE

  CODE
  Hide:Access:SPhones.Kill
  PARENT.Kill
  Relate:SPhones &= NULL


Hide:Access:States.Init PROCEDURE
  CODE
  SELF.Init(States,GlobalErrors)
  SELF.Buffer &= ST:Record
  SELF.LockRecover = 10
  SELF.AddKey(ST:StateKey,'State',0)
  Access:States &= SELF


Hide:Relate:States.Init PROCEDURE
  CODE
  Hide:Access:States.Init
  SELF.Init(Access:States,1)
  DO AddRelations_1

AddRelations_1 ROUTINE
  SELF.AddRelation(Relate:Members)


Hide:Access:States.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:States &= NULL


Hide:Relate:States.Kill PROCEDURE

  CODE
  Hide:Access:States.Kill
  PARENT.Kill
  Relate:States &= NULL

