

   MEMBER('Eventmgr.clw')                             ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABREPORT.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('EVENT003.INC'),ONCE        !Local module procedure declarations
                     END


Eventmgr_HelpAbout PROCEDURE                          !Generated from procedure template - Window

LocalRequest         LONG
FilesOpened          BYTE
RGBVal               LONG(00000000h)
Colors               GROUP,PRE(),OVER(RGBVal)
RedVal               BYTE
GreenVal             BYTE
BlueVal              BYTE
Phil                 BYTE
                     END
StartRGBVal          LONG(0808000H)
StartColors          GROUP,PRE(),OVER(StartRGBVal)
StartRedVal          BYTE
StartGreenVal        BYTE
StartBlueVal         BYTE
StartPhil            BYTE
                     END
ScaleWidth           LONG
ScaleHeight          LONG
Modifier             SHORT(1)
LOC:AboutJim         STRING(2000)
LOC:TextHidden       BYTE(1)
SoundFile            CSTRING(80)
window               WINDOW,AT(,,361,194),FONT('MS Sans Serif',8,,),CENTER,PALETTE(256),GRAY
                       STRING('Event Manager for Windows'),AT(0,7,361,22),USE(?String1),TRN,CENTER,FONT('Comic Sans MS',18,,)
                       STRING('Written by Jim DeFabia'),AT(2,26,359,12),USE(?String1:2),TRN,CENTER
                       PANEL,AT(18,51,131,139),USE(?Panel1),BEVEL(3,3)
                       TEXT,AT(164,51,180,139),USE(LOC:AboutJim),SKIP,FONT('MS Sans Serif',8,COLOR:Blue,),COLOR(COLOR:BTNFACE),READONLY
                       IMAGE('JIM-D.JPG'),AT(21,55,123,131),USE(?Image1)
                       REGION,AT(0,4,361,190),USE(?Region2),IMM
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
TakeFieldEvent         PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass

  CODE
  GlobalResponse = ThisWindow.Run()

ColorWindow ROUTINE
 !! This routine draws lines from the top down. Allowing all three colors to be modified
 !! creates a grayscale effect. Comment out any color or combination of 2 colors to get
 !! varying effects. Comment out Green and you get Purple. Comment out Red and you get Aqua.
 !!
 Window{PROP:Pixels} = TRUE
 ScaleWidth = Window{Prop:Width}
 ScaleHeight = Window{Prop:Width}
 DO Setcolors
 LOOP i# = 0 to ScaleHeight
  GreenVal= StartGreenVal - ((i# * (StartGreenVal / ScaleHeight)) * Modifier)
  RedVal= StartRedVal - ((i# * (StartRedVal / ScaleHeight))   * Modifier)
  BlueVal= StartBlueVal - ((i# * (StartBlueVal / ScaleHeight))  * Modifier)
   SETPENCOLOR(RgbVal)
   LINE(-1, i#-1 ,ScaleWidth,0)
 END
SetColors    ROUTINE
 GLO:StartCOLOR +=1
 IF GLO:StartCOLOR > 5 THEN GLO:StartCOLOR = 1.
 EXECUTE GLO:StartCOLOR
   BEGIN
    Modifier = 1
    StartRedVal     = 255
    StartGreenVal   = 100
    StartBlueVal    = 255
   END
   BEGIN
     Modifier = -1
     StartRedVal     = 0
     ! StartGreenVal   = 100
     StartBlueVal    = 0
   END
   BEGIN
     Modifier = 1
     StartRedVal     = 100
     ! StartGreenVal   = 100
     StartBlueVal    = 255
   END
   BEGIN
     Modifier = -1
     StartRedVal     = 100
     ! StartGreenVal   = 100
     StartBlueVal    = 100
   END
   BEGIN
     Modifier = 1
     StartRedVal     = 255
     ! StartGreenVal   = 100
     StartBlueVal    = 100
   END
 END

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Eventmgr_HelpAbout')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?String1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  LOC:AboutJim=|
    'Event Manager was written by Jim DeFabia. '&|
    'Jim was part of TopSpeed''s Documentation Team and '&|
    'was responsible for the on-line help systems, TopSpeed''s '&|
    'Internet Web Site--www.topspeed.com, and parts of '&|
    'the manuals.<13,10,13,10>'&|
    'He joined TopSpeed in 1993 with a background in '&|
    'Journalism and Computer Science. He has worked as a '&|
    'freelance reporter for an international news wire service and ' & |
    'an independant computer consultant specializing in applications ' &|
    'for the travel and tourism industry.<13,10,13,10>'&|
    'Jim co-authored Clarion for Windows for Dummies, published ' &|
    'by IDG Books (ISBN 1-56884-334-8), and writes a regular column for ClarionOnline.com ' &|
    'and ClarionMagazine.com<13,10,13,10>'
    
  
  OPEN(window)
  SELF.Opened=True
  DO ColorWindow
  
  IF DefaultSoundEnable
    SoundFile='drum.wav'
    sndPlaySound(SoundFile,1)
  END
  
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  SETCURSOR()
  
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE ACCEPTED()
    OF ?Region2
       POST(Event:CloseWindow)
    END
  ReturnValue = PARENT.TakeAccepted()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeFieldEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeFieldEvent()
  CASE FIELD()
  OF ?Region2
    CASE EVENT()
    OF EVENT:MouseIn
      SETCURSOR('~Finger.cur')
      
    OF EVENT:MouseOut
      SETCURSOR
      
    END
  END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

Eventmgr_PrintEventInvoice PROCEDURE                  !Generated from procedure template - Report

LocalRequest         LONG
FilesOpened          BYTE
LOC:CSZ              STRING(50)
LOC:EventNumber      LONG
Progress:Thermometer BYTE
Process:View         VIEW(Events)
                       PROJECT(EVE:Description)
                       PROJECT(EVE:Number)
                       PROJECT(EVE:Sponsor)
                       JOIN(SPO:KeySponsorNumber,EVE:Sponsor)
                         PROJECT(SPO:Address)
                         PROJECT(SPO:City)
                         PROJECT(SPO:CompanyName)
                         PROJECT(SPO:State)
                         PROJECT(SPO:Zip)
                       END
                       JOIN(LIN:KeyEventNumber,EVE:Number)
                         PROJECT(LIN:BillPrice)
                         PROJECT(LIN:Description)
                         PROJECT(LIN:Quantity)
                       END
                     END
ProgressWindow       WINDOW('Report Progress...'),AT(,,142,59),CENTER,TIMER(1),GRAY,DOUBLE
                       PROGRESS,USE(Progress:Thermometer),AT(15,15,111,12),RANGE(0,100)
                       STRING(''),AT(0,3,141,10),USE(?Progress:UserString),CENTER
                       STRING(''),AT(0,30,141,10),USE(?Progress:PctText),CENTER
                       BUTTON('Cancel'),AT(45,42,50,15),USE(?Progress:Cancel)
                     END

report               REPORT('Event Manager-Event Invoice'),AT(500,4104,8500,11000),PAPER(PAPER:USER,8500,11000),PRE(RPT),FONT('Arial',9,,),THOUS
                       HEADER,AT(750,750,7427,3500)
                         STRING(@s30),AT(354,1542),USE(SPO:CompanyName),LEFT
                         STRING(@s30),AT(354,1792),USE(SPO:Address),LEFT
                         STRING(@s20),AT(354,2031),USE(SPO:City)
                         STRING(@s2),AT(1906,2031),USE(SPO:State),LEFT
                         STRING(@n05),AT(2146,2031),USE(SPO:Zip),LEFT
                         STRING(@S25),AT(10,2313,6469,333),USE(EVE:Description),CENTER,FONT(,18,,FONT:bold)
                       END
detail                 DETAIL,AT(,,7677,302),USE(?detail)
                         STRING(@n3),AT(552,0),USE(LIN:Quantity),RIGHT
                         STRING(@s50),AT(2146,0),USE(LIN:Description)
                         STRING(@n7.2),AT(6104,0),USE(LIN:BillPrice),DECIMAL(200)
                       END
                       FOOTER,AT(500,9552,7677,302)
                         STRING(@n7.2),AT(6104,0),SUM,USE(LIN:BillPrice,,?LIN:BillPrice:2),DECIMAL(200)
                       END
                       FORM,AT(0,0,32767,11000)
                         IMAGE('HEADING.GIF'),AT(750,500,6719,813),USE(?Heading)
                         IMAGE('INVOICE.GIF'),AT(750,1344,6500,2667),USE(?Invoice)
                         LINE,AT(750,4302,6500,0),COLOR(COLOR:Black)
                         LINE,AT(750,4604,6500,0),COLOR(COLOR:Black)
                         LINE,AT(750,4906,6500,0),COLOR(COLOR:Black)
                         LINE,AT(750,5208,6500,0),COLOR(COLOR:Black)
                         LINE,AT(750,5510,6500,0),COLOR(COLOR:Black)
                         LINE,AT(750,5813,6500,0),COLOR(COLOR:Black)
                         LINE,AT(750,6115,6500,0),COLOR(COLOR:Black)
                         LINE,AT(750,6417,6500,0),COLOR(COLOR:Black)
                         LINE,AT(750,6719,6500,0),COLOR(COLOR:Black)
                         LINE,AT(750,7021,6500,0),COLOR(COLOR:Black)
                         LINE,AT(750,7323,6500,0),COLOR(COLOR:Black)
                         LINE,AT(750,7625,6500,0),COLOR(COLOR:Black)
                         LINE,AT(750,7927,6500,0),COLOR(COLOR:Black)
                         LINE,AT(750,8229,6500,0),COLOR(COLOR:Black)
                         LINE,AT(750,8531,6500,0),COLOR(COLOR:Black)
                         LINE,AT(750,8833,6500,0),COLOR(COLOR:Black)
                         LINE,AT(750,9135,6500,0),COLOR(COLOR:Black)
                         LINE,AT(750,9438,6500,0),COLOR(COLOR:Black)
                         LINE,AT(6344,9740,906,0),COLOR(COLOR:Black)
                         LINE,AT(750,3990,0,5448),COLOR(COLOR:Black)
                         LINE,AT(1625,3990,0,5448),COLOR(COLOR:Black)
                         LINE,AT(6344,3990,0,5750),COLOR(COLOR:Black)
                         LINE,AT(7240,3990,0,5750),COLOR(COLOR:Black)
                       END
                     END
ThisWindow           CLASS(ReportManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Reset                  PROCEDURE(BYTE Force=0),DERIVED
Update                 PROCEDURE(),DERIVED
                     END

ThisReport           CLASS(ProcessClass)              !Process Manager
TakeRecord             PROCEDURE(),BYTE,PROC,DERIVED
                     END

ProgressMgr          StepLongClass                    !Progress Manager
Previewer            PrintPreviewClass                !Print Previewer

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Eventmgr_PrintEventInvoice')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Progress:Thermometer
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  Relate:Events.Open
  SELF.FilesOpened = True
  IF NOT EVE:Number
    GLOBALRequest=SelectRecord
    Eventmgr_BrowseEvents
    IF GlobalResponse<>RequestCompleted
      RETURN Level:Fatal
    END
  END
  LOC:EventNumber=EVE:Number
  
  OPEN(ProgressWindow)
  SELF.Opened=True
  INIMgr.Fetch('Eventmgr_PrintEventInvoice',ProgressWindow)
  ProgressMgr.Init(ScrollSort:AllowNumeric,)
  ThisReport.Init(Process:View, Relate:Events, ?Progress:PctText, Progress:Thermometer, ProgressMgr, EVE:Number)
  ThisReport.AddSortOrder(EVE:KeyNumber)
  ThisReport.AddRange(EVE:Number,LOC:EventNumber)
  SELF.AddItem(?Progress:Cancel,RequestCancelled)
  SELF.Init(ThisReport,report,Previewer)
  ?Progress:UserString{Prop:Text}=''
  Relate:Events.SetQuickScan(1,Propagate:OneMany)
  Previewer.SetINIManager(INIMgr)
  Previewer.AllowUserZoom=True
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Events.Close
  END
  IF SELF.Opened
    INIMgr.Update('Eventmgr_PrintEventInvoice',ProgressWindow)
  END
  ProgressMgr.Kill()
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Reset PROCEDURE(BYTE Force=0)

  CODE
  SELF.ForcedReset += Force
  IF ProgressWindow{Prop:AcceptAll} THEN RETURN.
  SPO:SponsorNumber = EVE:Sponsor                     ! Assign linking field value
  Access:Sponsor.Fetch(SPO:KeySponsorNumber)
  LIN:EventNumber = EVE:Number                        ! Assign linking field value
  Access:LineItems.Fetch(LIN:KeyEventNumber)
  LOC:CSZ = CLIP(SPO:City) & ', ' & CLIP(SPO:State) & ' ' & SPO:Zip
  PARENT.Reset(Force)


ThisWindow.Update PROCEDURE

  CODE
  PARENT.Update
  SPO:SponsorNumber = EVE:Sponsor                     ! Assign linking field value
  Access:Sponsor.Fetch(SPO:KeySponsorNumber)
  LIN:EventNumber = EVE:Number                        ! Assign linking field value
  Access:LineItems.Fetch(LIN:KeyEventNumber)
  LOC:CSZ = CLIP(SPO:City) & ', ' & CLIP(SPO:State) & ' ' & SPO:Zip


ThisReport.TakeRecord PROCEDURE

ReturnValue          BYTE,AUTO

SkipDetails BYTE
  CODE
  LOC:CSZ = CLIP(SPO:City) & ', ' & CLIP(SPO:State) & ' ' & SPO:Zip
  ReturnValue = PARENT.TakeRecord()
  PRINT(RPT:detail)
  RETURN ReturnValue

Eventmgr_PrintTableSeatingList PROCEDURE              !Generated from procedure template - Report

LocalRequest         LONG
FilesOpened          BYTE
LOC:EventNumber      LONG
LOC:Unassigned       STRING(11)
Progress:Thermometer BYTE
Process:View         VIEW(Attendees)
                       PROJECT(ATT:Attendee)
                       PROJECT(ATT:EventNumber)
                       PROJECT(ATT:TableNumber)
                       JOIN(EVE:KeyNumber,ATT:EventNumber)
                         PROJECT(EVE:Description)
                       END
                       JOIN(MEM:MemberNumberKey,ATT:Attendee)
                         PROJECT(MEM:FirstName)
                         PROJECT(MEM:LastName)
                       END
                     END
ProgressWindow       WINDOW('Report Progress...'),AT(,,142,59),CENTER,TIMER(1),GRAY,DOUBLE
                       PROGRESS,USE(Progress:Thermometer),AT(15,15,111,12),RANGE(0,100)
                       STRING(''),AT(0,3,141,10),USE(?Progress:UserString),CENTER
                       STRING(''),AT(0,30,141,10),USE(?Progress:PctText),CENTER
                       BUTTON('Cancel'),AT(45,42,50,15),USE(?Progress:Cancel)
                     END

report               REPORT('Event Manager-Seating Chart'),AT(1000,1542,6000,7458),PRE(RPT),FONT('Arial',10,,),THOUS
                       HEADER,AT(1000,1000,6000,542)
                         BOX,AT(10,21,6052,240),USE(?Box2),COLOR(COLOR:Black)
                         STRING('Seating Arrangements for:'),AT(52,52,2552,219),TRN,CENTER,FONT(,,,FONT:bold)
                         STRING(@S25),AT(2448,52),USE(EVE:Description),TRN
                       END
break1                 BREAK(ATT:TableNumber)
                         HEADER,AT(10,10,6031,510)
                           STRING('Served'),AT(5000,73,333,385),USE(?String15),TRN,FONT('Arial',8,,),ANGLE(900)
                           BOX,AT(10,10,6031,542),FILL(COLOR:Silver)
                           STRING('Attendee'),AT(42,354,1896,167),TRN
                           STRING('Table Number'),AT(42,10,865,167),TRN
                           STRING(@n2),AT(948,10,604,281),USE(ATT:TableNumber),TRN,RIGHT(1),FONT('Arial',18,,FONT:bold)
                           STRING(@s11),AT(1740,42,1521,208),USE(LOC:Unassigned),TRN,FONT(,12,,FONT:bold)
                           STRING('RSVP'),AT(3563,73,281,385),USE(?String12),TRN,FONT('Arial',8,,),ANGLE(900)
                           STRING('Arrived'),AT(4052,73,281,385),USE(?String13),TRN,FONT('Arial',8,,),ANGLE(900)
                           STRING('Seated'),AT(4531,63,302,385),USE(?String14),TRN,FONT('Arial',8,,),ANGLE(900)
                         END
detail1                  DETAIL,AT(,,,208),USE(?detail1)
                           STRING(@s25),AT(10,10),USE(MEM:LastName)
                           STRING(@s20),AT(1906,10),USE(MEM:FirstName)
                           LINE,AT(3500,0,0,208),USE(?Line1),COLOR(COLOR:Black)
                           LINE,AT(4000,0,0,208),USE(?Line2),COLOR(COLOR:Black)
                           LINE,AT(4500,0,0,208),USE(?Line3),COLOR(COLOR:Black)
                           LINE,AT(5000,0,0,208),USE(?Line4),COLOR(COLOR:Black)
                           LINE,AT(5500,0,0,208),USE(?Line5),COLOR(COLOR:Black)
                           LINE,AT(6000,0,0,208),USE(?Line6),COLOR(COLOR:Black)
                           LINE,AT(0,208,6000,0),USE(?Line9),COLOR(COLOR:Black)
                         END
                         FOOTER,PAGEAFTER(-1),AT(0,0,,260)
                           STRING(@n4),AT(635,21),CNT,RESET(break1),USE(ATT:Attendee),TRN,RIGHT(1),FONT(,10,,)
                           STRING('seated at this Table'),AT(1073,21),USE(?String11),FONT(,10,,)
                         END
                       END
                       FOOTER,AT(1000,9000,6000,219)
                         STRING(@pPage <<<#p),AT(5250,31,698,135),PAGENO,USE(?PageCount),FONT('Arial',8,,FONT:regular)
                       END
                     END
ThisWindow           CLASS(ReportManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Reset                  PROCEDURE(BYTE Force=0),DERIVED
Update                 PROCEDURE(),DERIVED
                     END

ThisReport           CLASS(ProcessClass)              !Process Manager
TakeRecord             PROCEDURE(),BYTE,PROC,DERIVED
                     END

ProgressMgr          StepLongClass                    !Progress Manager
Previewer            PrintPreviewClass                !Print Previewer

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Eventmgr_PrintTableSeatingList')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Progress:Thermometer
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  Relate:Attendees.Open
  SELF.FilesOpened = True
  IF NOT EVE:Number
    GLOBALRequest=SelectRecord
    Eventmgr_BrowseEvents
    IF GlobalResponse<>RequestCompleted
      RETURN Level:Fatal
    END
  END
  LOC:EventNumber=EVE:Number
  
  OPEN(ProgressWindow)
  SELF.Opened=True
  INIMgr.Fetch('Eventmgr_PrintTableSeatingList',ProgressWindow)
  ProgressMgr.Init(ScrollSort:AllowNumeric,)
  ThisReport.Init(Process:View, Relate:Attendees, ?Progress:PctText, Progress:Thermometer, ProgressMgr, ATT:TableNumber)
  ThisReport.AddSortOrder(ATT:KeyEventTableAttendee)
  ThisReport.AddRange(ATT:EventNumber,LOC:EventNumber)
  SELF.AddItem(?Progress:Cancel,RequestCancelled)
  SELF.Init(ThisReport,report,Previewer)
  ?Progress:UserString{Prop:Text}=''
  Relate:Attendees.SetQuickScan(1,Propagate:OneMany)
  Previewer.SetINIManager(INIMgr)
  Previewer.AllowUserZoom=True
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Attendees.Close
  END
  IF SELF.Opened
    INIMgr.Update('Eventmgr_PrintTableSeatingList',ProgressWindow)
  END
  ProgressMgr.Kill()
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Reset PROCEDURE(BYTE Force=0)

  CODE
  SELF.ForcedReset += Force
  IF ProgressWindow{Prop:AcceptAll} THEN RETURN.
  EVE:Number = ATT:EventNumber                        ! Assign linking field value
  Access:Events.Fetch(EVE:KeyNumber)
  MEM:MemberNumber = ATT:Attendee                     ! Assign linking field value
  Access:Members.Fetch(MEM:MemberNumberKey)
  IF (ATT:TableNumber = 0)
    LOC:Unassigned = 'Unassigned'
  ELSE
    LOC:Unassigned = ''
  END
  PARENT.Reset(Force)


ThisWindow.Update PROCEDURE

  CODE
  PARENT.Update
  EVE:Number = ATT:EventNumber                        ! Assign linking field value
  Access:Events.Fetch(EVE:KeyNumber)
  MEM:MemberNumber = ATT:Attendee                     ! Assign linking field value
  Access:Members.Fetch(MEM:MemberNumberKey)
  IF (ATT:TableNumber = 0)
    LOC:Unassigned = 'Unassigned'
  ELSE
    LOC:Unassigned = ''
  END


ThisReport.TakeRecord PROCEDURE

ReturnValue          BYTE,AUTO

SkipDetails BYTE
  CODE
  IF (ATT:TableNumber = 0)
    LOC:Unassigned = 'Unassigned'
  ELSE
    LOC:Unassigned = ''
  END
  ReturnValue = PARENT.TakeRecord()
  PRINT(RPT:detail1)
  RETURN ReturnValue

Eventmgr_PrintEventSummary PROCEDURE                  !Generated from procedure template - Report

LocalRequest         LONG
FilesOpened          BYTE
LOC:EventNumber      LONG
Progress:Thermometer BYTE
Process:View         VIEW(LineItems)
                       PROJECT(LIN:ActualCost)
                       PROJECT(LIN:BillPrice)
                       PROJECT(LIN:BudgetCost)
                       PROJECT(LIN:Description)
                       PROJECT(LIN:EventNumber)
                       PROJECT(LIN:Quantity)
                       JOIN(EVE:KeyNumber,LIN:EventNumber)
                         PROJECT(EVE:Date)
                         PROJECT(EVE:Description)
                         PROJECT(EVE:Sponsor)
                         JOIN(SPO:KeySponsorNumber,EVE:Sponsor)
                           PROJECT(SPO:CompanyName)
                         END
                       END
                     END
ProgressWindow       WINDOW('Report Progress...'),AT(,,142,59),CENTER,TIMER(1),GRAY,DOUBLE
                       PROGRESS,USE(Progress:Thermometer),AT(15,15,111,12),RANGE(0,100)
                       STRING(''),AT(0,3,141,10),USE(?Progress:UserString),CENTER
                       STRING(''),AT(0,30,141,10),USE(?Progress:PctText),CENTER
                       BUTTON('Cancel'),AT(45,42,50,15),USE(?Progress:Cancel)
                     END

report               REPORT('Event Manager-Event Summary'),AT(1000,2344,6000,6667),PRE(RPT),FONT('Arial',10,,),THOUS
                       HEADER,AT(1000,1000,5990,1344),ABSOLUTE
                         LINE,AT(2063,1073,0,260),USE(?Line9:2),COLOR(COLOR:Black)
                         LINE,AT(3063,1073,0,260),USE(?Line9),COLOR(COLOR:Black)
                         LINE,AT(594,1094,0,271),USE(?Line8:10),COLOR(COLOR:Black)
                         LINE,AT(552,1073,0,271),USE(?Line8:9),COLOR(COLOR:Black)
                         STRING(@D2),AT(4604,302,1063,167),USE(EVE:Date),LEFT(1)
                         STRING('Event Summary for:'),AT(208,281,1646,219),CENTER,FONT(,,,FONT:bold)
                         STRING(@S25),AT(1948,281,1896,167),USE(EVE:Description)
                         STRING(@S25),AT(1948,563),USE(SPO:CompanyName)
                         BOX,AT(177,229,5635,677),USE(?Box3),COLOR(COLOR:Black),LINEWIDTH(2)
                         BOX,AT(0,1073,6000,271),COLOR(COLOR:Black),FILL(COLOR:Silver)
                         STRING('Description'),AT(1115,1104,1115,208),TRN
                         STRING('Quantity'),AT(73,1104),USE(?String16),TRN
                         STRING('Budget'),AT(3094,1104,688,208),USE(?String15),TRN
                         STRING('Billed'),AT(4896,1104,688,208),USE(?String16:3),TRN
                         STRING('Actual'),AT(4021,1104,688,208),USE(?String16:2),TRN
                       END
break1                 BREAK(LIN:EventNumber)
detail1                  DETAIL,AT(,,,281),USE(?detail1)
                           STRING(@n3),AT(115,42),USE(LIN:Quantity),RIGHT(1)
                           STRING(@S25),AT(740,42),USE(LIN:Description)
                           STRING(@n$7.2),AT(4083,52),USE(LIN:ActualCost),RIGHT
                           STRING(@n$7.2),AT(3208,52),USE(LIN:BudgetCost),RIGHT
                           STRING(@n$7.2),AT(4896,42),USE(LIN:BillPrice),RIGHT,FONT('Arial',10,,)
                           LINE,AT(594,0,0,302),USE(?Line8:2),COLOR(COLOR:Black)
                           LINE,AT(3896,0,0,302),USE(?Line8:7),COLOR(COLOR:Black)
                           LINE,AT(4698,0,0,302),USE(?Line8:6),COLOR(COLOR:Black)
                           LINE,AT(31,292,5917,0),USE(?Line7),COLOR(COLOR:Black)
                           LINE,AT(3000,0,0,302),USE(?Line8),COLOR(COLOR:Black)
                         END
                         FOOTER,AT(0,0)
                           BOX,AT(0,0,5990,375),USE(?Box2),ROUND,COLOR(COLOR:Black)
                           LINE,AT(3000,0,0,375),USE(?Line8:4),COLOR(COLOR:Black)
                           LINE,AT(3896,0,0,375),USE(?Line8:3),COLOR(COLOR:Black)
                           LINE,AT(4698,0,0,375),USE(?Line8:5),COLOR(COLOR:Black)
                           STRING(@n$8.2),AT(4813,52),SUM,RESET(break1),USE(LIN:BillPrice,,?LIN:BillPrice:2),RIGHT(12),FONT('Arial',10,,)
                           STRING(@n$8.2),AT(4000,63),SUM,RESET(break1),USE(LIN:ActualCost,,?LIN:ActualCost:2),RIGHT(12)
                           STRING(@n$8.2),AT(3125,73),SUM,USE(LIN:BudgetCost,,?LIN:BudgetCost:2),RIGHT(12)
                         END
                       END
                     END
ThisWindow           CLASS(ReportManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Reset                  PROCEDURE(BYTE Force=0),DERIVED
Update                 PROCEDURE(),DERIVED
                     END

ThisReport           CLASS(ProcessClass)              !Process Manager
TakeRecord             PROCEDURE(),BYTE,PROC,DERIVED
                     END

ProgressMgr          StepLongClass                    !Progress Manager
Previewer            PrintPreviewClass                !Print Previewer

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Eventmgr_PrintEventSummary')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Progress:Thermometer
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  Relate:LineItems.Open
  SELF.FilesOpened = True
  IF NOT EVE:Number
    GLOBALRequest=SelectRecord
    Eventmgr_BrowseEvents
    IF GlobalResponse<>RequestCompleted
      RETURN Level:Fatal
    END
  END
  LOC:EventNumber=EVE:Number
  
  OPEN(ProgressWindow)
  SELF.Opened=True
  INIMgr.Fetch('Eventmgr_PrintEventSummary',ProgressWindow)
  ProgressMgr.Init(ScrollSort:AllowNumeric,)
  ThisReport.Init(Process:View, Relate:LineItems, ?Progress:PctText, Progress:Thermometer, ProgressMgr, LIN:EventNumber)
  ThisReport.AddSortOrder(LIN:KeyEventNumber)
  ThisReport.AddRange(LIN:EventNumber,LOC:EventNumber)
  SELF.AddItem(?Progress:Cancel,RequestCancelled)
  SELF.Init(ThisReport,report,Previewer)
  ?Progress:UserString{Prop:Text}=''
  Relate:LineItems.SetQuickScan(1,Propagate:OneMany)
  Previewer.SetINIManager(INIMgr)
  Previewer.AllowUserZoom=True
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:LineItems.Close
  END
  IF SELF.Opened
    INIMgr.Update('Eventmgr_PrintEventSummary',ProgressWindow)
  END
  ProgressMgr.Kill()
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Reset PROCEDURE(BYTE Force=0)

  CODE
  SELF.ForcedReset += Force
  IF ProgressWindow{Prop:AcceptAll} THEN RETURN.
  EVE:Number = LIN:EventNumber                        ! Assign linking field value
  Access:Events.Fetch(EVE:KeyNumber)
  SPO:SponsorNumber = EVE:Sponsor                     ! Assign linking field value
  Access:Sponsor.Fetch(SPO:KeySponsorNumber)
  PARENT.Reset(Force)


ThisWindow.Update PROCEDURE

  CODE
  PARENT.Update
  EVE:Number = LIN:EventNumber                        ! Assign linking field value
  Access:Events.Fetch(EVE:KeyNumber)
  SPO:SponsorNumber = EVE:Sponsor                     ! Assign linking field value
  Access:Sponsor.Fetch(SPO:KeySponsorNumber)


ThisReport.TakeRecord PROCEDURE

ReturnValue          BYTE,AUTO

SkipDetails BYTE
  CODE
  ReturnValue = PARENT.TakeRecord()
  PRINT(RPT:detail1)
  RETURN ReturnValue

Eventmgr_PrintMemberLabels PROCEDURE                  !Generated from procedure template - Report

LocalRequest         LONG
FilesOpened          BYTE
LOC:Name             STRING(45)
LOC:CSZ              STRING(40)
LOC:Line3            STRING(40)
LOC:Line4            STRING(40)
Progress:Thermometer BYTE
Process:View         VIEW(Members)
                       PROJECT(MEM:Address)
                       PROJECT(MEM:Address2)
                       PROJECT(MEM:City)
                       PROJECT(MEM:FirstName)
                       PROJECT(MEM:LastName)
                       PROJECT(MEM:State)
                       PROJECT(MEM:ZIPCode)
                     END
ProgressWindow       WINDOW('Report Progress...'),AT(,,142,59),CENTER,TIMER(1),GRAY,DOUBLE
                       PROGRESS,USE(Progress:Thermometer),AT(15,15,111,12),RANGE(0,100)
                       STRING(''),AT(0,3,141,10),USE(?Progress:UserString),CENTER
                       STRING(''),AT(0,30,141,10),USE(?Progress:PctText),CENTER
                       BUTTON('Cancel'),AT(45,42,50,15),USE(?Progress:Cancel)
                     END

report               REPORT('Event Manager-Member Labels'),AT(250,500,8500,11000),PAPER(PAPER:LETTER),PRE(RPT),FONT('Arial',8,,),THOUS
detail                 DETAIL,AT(,,2750,1000),USE(?detail)
                         STRING(@s45),AT(104,156,2650,150),USE(LOC:Name),LEFT
                         STRING(@s40),AT(104,344,2650,150),USE(MEM:Address),LEFT
                         STRING(@s40),AT(104,531,2650,150),USE(LOC:Line3)
                         STRING(@s40),AT(104,719,2650,150),USE(LOC:Line4)
                       END
                     END
ThisWindow           CLASS(ReportManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
                     END

ThisReport           CLASS(ProcessClass)              !Process Manager
TakeRecord             PROCEDURE(),BYTE,PROC,DERIVED
                     END

ProgressMgr          StepStringClass                  !Progress Manager
Previewer            PrintPreviewClass                !Print Previewer

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Eventmgr_PrintMemberLabels')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Progress:Thermometer
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  Relate:Members.Open
  SELF.FilesOpened = True
  OPEN(ProgressWindow)
  SELF.Opened=True
  INIMgr.Fetch('Eventmgr_PrintMemberLabels',ProgressWindow)
  ProgressMgr.Init(ScrollSort:AllowAlpha+ScrollSort:AllowNumeric,ScrollBy:RunTime)
  ThisReport.Init(Process:View, Relate:Members, ?Progress:PctText, Progress:Thermometer, ProgressMgr, MEM:ZIPCode)
  ThisReport.CaseSensitiveValue = FALSE
  ThisReport.AddSortOrder(MEM:ZipCodeKey)
  SELF.AddItem(?Progress:Cancel,RequestCancelled)
  SELF.Init(ThisReport,report,Previewer)
  ?Progress:UserString{Prop:Text}=''
  Relate:Members.SetQuickScan(1,Propagate:OneMany)
  Previewer.SetINIManager(INIMgr)
  Previewer.AllowUserZoom=True
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Members.Close
  END
  IF SELF.Opened
    INIMgr.Update('Eventmgr_PrintMemberLabels',ProgressWindow)
  END
  ProgressMgr.Kill()
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisReport.TakeRecord PROCEDURE

ReturnValue          BYTE,AUTO

SkipDetails BYTE
  CODE
  LOC:Name = CLIP(MEM:FirstName) & ' ' & CLIP(MEM:LastName)
  LOC:CSZ = CLIP(MEM:City) & ', ' & CLIP(MEM:State) & ' ' & MEM:ZIPCode
  IF (MEM:Address2)
    LOC:Line3 = MEM:Address2
  ELSE
    LOC:Line3 = LOC:CSZ
  END
  IF (MEM:Address2)
    LOC:Line4 = LOC:CSZ
  ELSE
    LOC:Line4 = ''
  END
  ReturnValue = PARENT.TakeRecord()
  PRINT(RPT:detail)
  RETURN ReturnValue

Eventmgr_PrintMemberList PROCEDURE                    !Generated from procedure template - Report

LocalRequest         LONG
FilesOpened          BYTE
LOC:Name             STRING(40)
Progress:Thermometer BYTE
Process:View         VIEW(Members)
                       PROJECT(MEM:Address)
                       PROJECT(MEM:City)
                       PROJECT(MEM:FirstName)
                       PROJECT(MEM:LastName)
                       PROJECT(MEM:MiddleName)
                       PROJECT(MEM:State)
                       PROJECT(MEM:ZIPCode)
                       PROJECT(MEM:MemberNumber)
                       JOIN(MPH:KeyMemberNumber,MEM:MemberNumber)
                         PROJECT(MPH:Description)
                         PROJECT(MPH:PhoneNumber)
                       END
                     END
ProgressWindow       WINDOW('Report Progress...'),AT(,,142,59),CENTER,TIMER(1),GRAY,DOUBLE
                       PROGRESS,USE(Progress:Thermometer),AT(15,15,111,12),RANGE(0,100)
                       STRING(''),AT(0,3,141,10),USE(?Progress:UserString),CENTER
                       STRING(''),AT(0,30,141,10),USE(?Progress:PctText),CENTER
                       BUTTON('Cancel'),AT(45,42,50,15),USE(?Progress:Cancel)
                     END

report               REPORT('Event Manager-Member List'),AT(1000,1719,6000,7281),PRE(RPT),FONT('Arial',10,,),THOUS
                       HEADER,AT(1000,1000,6000,677)
                         BOX,AT(10,10,5990,656),COLOR(COLOR:Black),FILL(COLOR:Silver)
                         STRING('Member List'),AT(10,104,5990,490),TRN,CENTER,FONT('Arial',24,,FONT:bold)
                       END
break1                 BREAK(MPH:MemberNumber)
                         HEADER,AT(0,0,6010,635)
                           BOX,AT(10,42,6000,583),USE(?Box2),COLOR(COLOR:Black)
                           LINE,AT(10,10,5990,0),USE(?Line2),COLOR(COLOR:Black),LINEWIDTH(5)
                           STRING(@S25),AT(10,63,1396,167),USE(LOC:Name),TRN
                           STRING(@S25),AT(10,240,1396,167),USE(MEM:Address),TRN
                           STRING(@s2),AT(1469,427,271,167),USE(MEM:State),TRN
                           STRING(@S25),AT(21,427,1396,167),USE(MEM:City),TRN
                           STRING(@s10),AT(1688,427,969,167),USE(MEM:ZIPCode),TRN,RIGHT(1)
                         END
detail                   DETAIL,AT(10,10,2438,271),USE(?detail)
                           STRING(@s10),AT(73,31),USE(MPH:Description)
                           STRING(@s20),AT(844,31),USE(MPH:PhoneNumber)
                         END
                       END
                       FOOTER,AT(1000,9000,6000,219)
                         STRING(@pPage <<<#p),AT(5250,31,698,135),PAGENO,USE(?PageCount),FONT('Arial',8,,FONT:regular)
                       END
                     END
ThisWindow           CLASS(ReportManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Reset                  PROCEDURE(BYTE Force=0),DERIVED
Update                 PROCEDURE(),DERIVED
                     END

ThisReport           CLASS(ProcessClass)              !Process Manager
TakeRecord             PROCEDURE(),BYTE,PROC,DERIVED
                     END

ProgressMgr          StepStringClass                  !Progress Manager
Previewer            PrintPreviewClass                !Print Previewer

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Eventmgr_PrintMemberList')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Progress:Thermometer
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  Relate:Members.Open
  SELF.FilesOpened = True
  OPEN(ProgressWindow)
  SELF.Opened=True
  INIMgr.Fetch('Eventmgr_PrintMemberList',ProgressWindow)
  ProgressMgr.Init(ScrollSort:AllowAlpha+ScrollSort:AllowNumeric,ScrollBy:RunTime)
  ThisReport.Init(Process:View, Relate:Members, ?Progress:PctText, Progress:Thermometer, ProgressMgr, MEM:LastName)
  ThisReport.CaseSensitiveValue = FALSE
  ThisReport.AddSortOrder(MEM:NameKey)
  SELF.AddItem(?Progress:Cancel,RequestCancelled)
  SELF.Init(ThisReport,report,Previewer)
  ?Progress:UserString{Prop:Text}=''
  Relate:Members.SetQuickScan(1,Propagate:OneMany)
  Previewer.SetINIManager(INIMgr)
  Previewer.AllowUserZoom=True
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Members.Close
  END
  IF SELF.Opened
    INIMgr.Update('Eventmgr_PrintMemberList',ProgressWindow)
  END
  ProgressMgr.Kill()
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Reset PROCEDURE(BYTE Force=0)

  CODE
  SELF.ForcedReset += Force
  IF ProgressWindow{Prop:AcceptAll} THEN RETURN.
  MPH:MemberNumber = MEM:MemberNumber                 ! Assign linking field value
  Access:MPhones.Fetch(MPH:KeyMemberNumber)
  PARENT.Reset(Force)


ThisWindow.Update PROCEDURE

  CODE
  PARENT.Update
  MPH:MemberNumber = MEM:MemberNumber                 ! Assign linking field value
  Access:MPhones.Fetch(MPH:KeyMemberNumber)


ThisReport.TakeRecord PROCEDURE

ReturnValue          BYTE,AUTO

SkipDetails BYTE
  CODE
  LOC:Name = CLIP(MEM:FirstName) & ' ' & CLIP(MEM:MiddleName) & ' ' & CLIP(MEM:LastName)
  ReturnValue = PARENT.TakeRecord()
  PRINT(RPT:detail)
  RETURN ReturnValue

Eventmgr_PrintNameBadges PROCEDURE                    !Generated from procedure template - Report

LocalRequest         LONG
FilesOpened          BYTE
LOC:EventNumber      LONG
Progress:Thermometer BYTE
Process:View         VIEW(Attendees)
                       PROJECT(ATT:Attendee)
                       PROJECT(ATT:EventNumber)
                       PROJECT(ATT:TableNumber)
                       JOIN(EVE:KeyNumber,ATT:EventNumber)
                         PROJECT(EVE:Description)
                       END
                       JOIN(MEM:MemberNumberKey,ATT:Attendee)
                         PROJECT(MEM:FirstName)
                         PROJECT(MEM:LastName)
                       END
                     END
ProgressWindow       WINDOW('Report Progress...'),AT(,,142,59),CENTER,TIMER(1),GRAY,DOUBLE
                       PROGRESS,USE(Progress:Thermometer),AT(15,15,111,12),RANGE(0,100)
                       STRING(''),AT(0,3,141,10),USE(?Progress:UserString),CENTER
                       STRING(''),AT(0,30,141,10),USE(?Progress:PctText),CENTER
                       BUTTON('Cancel'),AT(45,42,50,15),USE(?Progress:Cancel)
                     END

Report               REPORT('Event Manager-Event Name Badges'),AT(250,1000,8500,11000),PAPER(PAPER:LETTER),PRE(RPT),THOUS
detail                 DETAIL,AT(,,3990,2990),USE(?detail)
                         STRING(@S25),AT(10,375,3979,240),USE(EVE:Description),TRN,CENTER,FONT('Times New Roman',16,,FONT:bold+FONT:italic)
                         STRING(@s25),AT(10,1583,3969,250),USE(MEM:LastName),TRN,CENTER,FONT('Arial',16,,FONT:bold)
                         BOX,AT(385,250,3208,2479),USE(?Box1),COLOR(COLOR:Black),LINEWIDTH(3)
                         STRING(@s20),AT(10,1052,3969,406),USE(MEM:FirstName),TRN,CENTER,FONT('Arial',20,,FONT:bold)
                       END
                     END
ThisWindow           CLASS(ReportManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Reset                  PROCEDURE(BYTE Force=0),DERIVED
Update                 PROCEDURE(),DERIVED
                     END

ThisReport           CLASS(ProcessClass)              !Process Manager
TakeRecord             PROCEDURE(),BYTE,PROC,DERIVED
                     END

ProgressMgr          StepLongClass                    !Progress Manager
Previewer            PrintPreviewClass                !Print Previewer

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Eventmgr_PrintNameBadges')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Progress:Thermometer
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  Relate:Attendees.Open
  SELF.FilesOpened = True
  IF NOT EVE:Number
    GLOBALRequest=SelectRecord
    Eventmgr_BrowseEvents
    IF GlobalResponse<>RequestCompleted
      RETURN Level:Fatal
    END
  END
  LOC:EventNumber=EVE:Number
  
  OPEN(ProgressWindow)
  SELF.Opened=True
  INIMgr.Fetch('Eventmgr_PrintNameBadges',ProgressWindow)
  ProgressMgr.Init(ScrollSort:AllowNumeric,)
  ThisReport.Init(Process:View, Relate:Attendees, ?Progress:PctText, Progress:Thermometer, 100)
  ThisReport.AddSortOrder(ATT:KeyEventTableAttendee)
  ThisReport.AddRange(ATT:EventNumber,LOC:EventNumber)
  SELF.AddItem(?Progress:Cancel,RequestCancelled)
  SELF.Init(ThisReport,Report,Previewer)
  ?Progress:UserString{Prop:Text}=''
  Relate:Attendees.SetQuickScan(1,Propagate:OneMany)
  Previewer.SetINIManager(INIMgr)
  Previewer.AllowUserZoom=True
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Attendees.Close
  END
  IF SELF.Opened
    INIMgr.Update('Eventmgr_PrintNameBadges',ProgressWindow)
  END
  ProgressMgr.Kill()
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Reset PROCEDURE(BYTE Force=0)

  CODE
  SELF.ForcedReset += Force
  IF ProgressWindow{Prop:AcceptAll} THEN RETURN.
  EVE:Number = ATT:EventNumber                        ! Assign linking field value
  Access:Events.Fetch(EVE:KeyNumber)
  MEM:MemberNumber = ATT:Attendee                     ! Assign linking field value
  Access:Members.Fetch(MEM:MemberNumberKey)
  PARENT.Reset(Force)


ThisWindow.Update PROCEDURE

  CODE
  PARENT.Update
  EVE:Number = ATT:EventNumber                        ! Assign linking field value
  Access:Events.Fetch(EVE:KeyNumber)
  MEM:MemberNumber = ATT:Attendee                     ! Assign linking field value
  Access:Members.Fetch(MEM:MemberNumberKey)


ThisReport.TakeRecord PROCEDURE

ReturnValue          BYTE,AUTO

SkipDetails BYTE
  CODE
  ReturnValue = PARENT.TakeRecord()
  PRINT(RPT:detail)
  RETURN ReturnValue

Eventmgr_PrintPlaceCards PROCEDURE                    !Generated from procedure template - Report

LocalRequest         LONG
FilesOpened          BYTE
LOC:EventNumber      LONG
Progress:Thermometer BYTE
Process:View         VIEW(Attendees)
                       PROJECT(ATT:Attendee)
                       PROJECT(ATT:EventNumber)
                       PROJECT(ATT:TableNumber)
                       JOIN(EVE:KeyNumber,ATT:EventNumber)
                       END
                       JOIN(MEM:MemberNumberKey,ATT:Attendee)
                         PROJECT(MEM:FirstName)
                         PROJECT(MEM:LastName)
                       END
                     END
ProgressWindow       WINDOW('Report Progress...'),AT(,,142,59),CENTER,TIMER(1),GRAY,DOUBLE
                       PROGRESS,USE(Progress:Thermometer),AT(15,15,111,12),RANGE(0,100)
                       STRING(''),AT(0,3,141,10),USE(?Progress:UserString),CENTER
                       STRING(''),AT(0,30,141,10),USE(?Progress:PctText),CENTER
                       BUTTON('Cancel'),AT(45,42,50,15),USE(?Progress:Cancel)
                     END

Report               REPORT('Event Manager-Event Place Cards'),AT(250,1000,8500,11000),PAPER(PAPER:LETTER),PRE(RPT),THOUS
detail                 DETAIL,AT(,,3990,2990),USE(?detail)
                         STRING(@n2),AT(417,1500,521,260),USE(ATT:TableNumber),TRN,CENTER(1),FONT('Times New Roman',14,,FONT:regular)
                         STRING(@n2),AT(2990,1167,583,500),USE(ATT:TableNumber,,?ATT:TableNumber:2),TRN,CENTER(1),FONT('Times New Roman',14,,FONT:regular),ANGLE(1800)
                         STRING(@s25),AT(10,2375,3969,250),USE(MEM:LastName),TRN,CENTER,FONT('Arial',16,,FONT:bold)
                         BOX,AT(385,250,3208,2479),USE(?Box1),COLOR(COLOR:Black),LINEWIDTH(3)
                         STRING(@s25),AT(21,344,3969,510),USE(MEM:LastName,,?MEM:LastName:2),TRN,CENTER,FONT('Arial',16,,FONT:bold),ANGLE(1800)
                         STRING(@s20),AT(10,1844,3969,406),USE(MEM:FirstName),TRN,CENTER,FONT('Arial',20,,FONT:bold)
                         STRING(@s20),AT(10,823,3969,656),USE(MEM:FirstName,,?MEM:FirstName:2),TRN,CENTER,FONT('Arial',20,,FONT:bold),ANGLE(1800)
                         LINE,AT(10,1490,3969,0),USE(?Line1),COLOR(COLOR:Black)
                       END
                     END
ThisWindow           CLASS(ReportManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Reset                  PROCEDURE(BYTE Force=0),DERIVED
Update                 PROCEDURE(),DERIVED
                     END

ThisReport           CLASS(ProcessClass)              !Process Manager
TakeRecord             PROCEDURE(),BYTE,PROC,DERIVED
                     END

ProgressMgr          StepLongClass                    !Progress Manager
Previewer            PrintPreviewClass                !Print Previewer

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Eventmgr_PrintPlaceCards')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Progress:Thermometer
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  Relate:Attendees.Open
  SELF.FilesOpened = True
  IF NOT EVE:Number
    GLOBALRequest=SelectRecord
    Eventmgr_BrowseEvents
    IF GlobalResponse<>RequestCompleted
      RETURN Level:Fatal
    END
  END
  LOC:EventNumber=EVE:Number
  
  OPEN(ProgressWindow)
  SELF.Opened=True
  INIMgr.Fetch('Eventmgr_PrintPlaceCards',ProgressWindow)
  ProgressMgr.Init(ScrollSort:AllowNumeric,)
  ThisReport.Init(Process:View, Relate:Attendees, ?Progress:PctText, Progress:Thermometer, 100)
  ThisReport.AddSortOrder(ATT:KeyEventTableAttendee)
  ThisReport.AddRange(ATT:EventNumber,LOC:EventNumber)
  SELF.AddItem(?Progress:Cancel,RequestCancelled)
  SELF.Init(ThisReport,Report,Previewer)
  ?Progress:UserString{Prop:Text}=''
  Relate:Attendees.SetQuickScan(1,Propagate:OneMany)
  Previewer.SetINIManager(INIMgr)
  Previewer.AllowUserZoom=True
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Attendees.Close
  END
  IF SELF.Opened
    INIMgr.Update('Eventmgr_PrintPlaceCards',ProgressWindow)
  END
  ProgressMgr.Kill()
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Reset PROCEDURE(BYTE Force=0)

  CODE
  SELF.ForcedReset += Force
  IF ProgressWindow{Prop:AcceptAll} THEN RETURN.
  EVE:Number = ATT:EventNumber                        ! Assign linking field value
  Access:Events.Fetch(EVE:KeyNumber)
  MEM:MemberNumber = ATT:Attendee                     ! Assign linking field value
  Access:Members.Fetch(MEM:MemberNumberKey)
  PARENT.Reset(Force)


ThisWindow.Update PROCEDURE

  CODE
  PARENT.Update
  EVE:Number = ATT:EventNumber                        ! Assign linking field value
  Access:Events.Fetch(EVE:KeyNumber)
  MEM:MemberNumber = ATT:Attendee                     ! Assign linking field value
  Access:Members.Fetch(MEM:MemberNumberKey)


ThisReport.TakeRecord PROCEDURE

ReturnValue          BYTE,AUTO

SkipDetails BYTE
  CODE
  ReturnValue = PARENT.TakeRecord()
  PRINT(RPT:detail)
  RETURN ReturnValue

Eventmgr_PrintSponsorLabels PROCEDURE                 !Generated from procedure template - Report

LocalRequest         LONG
FilesOpened          BYTE
LOC:Name             STRING(45)
LOC:CSZ              STRING(40)
LOC:Line3            STRING(40)
LOC:Line4            STRING(40)
Progress:Thermometer BYTE
Process:View         VIEW(Sponsor)
                       PROJECT(SPO:Address)
                       PROJECT(SPO:Address2)
                       PROJECT(SPO:City)
                       PROJECT(SPO:CompanyName)
                       PROJECT(SPO:State)
                       PROJECT(SPO:Zip)
                     END
ProgressWindow       WINDOW('Report Progress...'),AT(,,142,59),CENTER,TIMER(1),GRAY,DOUBLE
                       PROGRESS,USE(Progress:Thermometer),AT(15,15,111,12),RANGE(0,100)
                       STRING(''),AT(0,3,141,10),USE(?Progress:UserString),CENTER
                       STRING(''),AT(0,30,141,10),USE(?Progress:PctText),CENTER
                       BUTTON('Cancel'),AT(45,42,50,15),USE(?Progress:Cancel)
                     END

report               REPORT('Event Manager-Sponsor Labels'),AT(250,500,8500,11000),PAPER(PAPER:LETTER),PRE(RPT),FONT('Arial',8,,),THOUS
detail                 DETAIL,AT(,,2750,1000),USE(?detail)
                         STRING(@S40),AT(104,156,2650,150),USE(SPO:CompanyName),LEFT
                         STRING(@S40),AT(104,344,2650,150),USE(SPO:Address),LEFT
                         STRING(@s40),AT(104,531,2650,150),USE(LOC:Line3),SKIP
                         STRING(@s40),AT(104,719,2650,150),USE(LOC:Line4)
                       END
                     END
ThisWindow           CLASS(ReportManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
                     END

ThisReport           CLASS(ProcessClass)              !Process Manager
TakeRecord             PROCEDURE(),BYTE,PROC,DERIVED
                     END

ProgressMgr          StepStringClass                  !Progress Manager
Previewer            PrintPreviewClass                !Print Previewer

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Eventmgr_PrintSponsorLabels')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Progress:Thermometer
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  Relate:Sponsor.Open
  SELF.FilesOpened = True
  OPEN(ProgressWindow)
  SELF.Opened=True
  INIMgr.Fetch('Eventmgr_PrintSponsorLabels',ProgressWindow)
  ProgressMgr.Init(ScrollSort:AllowAlpha+ScrollSort:AllowNumeric,ScrollBy:RunTime)
  ThisReport.Init(Process:View, Relate:Sponsor, ?Progress:PctText, Progress:Thermometer, ProgressMgr, SPO:Zip)
  ThisReport.CaseSensitiveValue = FALSE
  ThisReport.AddSortOrder(SPO:KeyZip)
  SELF.AddItem(?Progress:Cancel,RequestCancelled)
  SELF.Init(ThisReport,report,Previewer)
  ?Progress:UserString{Prop:Text}=''
  Relate:Sponsor.SetQuickScan(1,Propagate:OneMany)
  Previewer.SetINIManager(INIMgr)
  Previewer.AllowUserZoom=True
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Sponsor.Close
  END
  IF SELF.Opened
    INIMgr.Update('Eventmgr_PrintSponsorLabels',ProgressWindow)
  END
  ProgressMgr.Kill()
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisReport.TakeRecord PROCEDURE

ReturnValue          BYTE,AUTO

SkipDetails BYTE
  CODE
  LOC:CSZ = CLIP(SPO:City) & ', ' & CLIP(SPO:State) & ' ' & SPO:Zip
  IF (SPO:Address2)
    LOC:Line3 = SPO:Address2
  ELSE
    LOC:Line3 = LOC:CSZ
  END
  IF (SPO:Address2)
    LOC:Line4 = LOC:CSZ
  ELSE
    LOC:Line4 = ''
  END
  ReturnValue = PARENT.TakeRecord()
  PRINT(RPT:detail)
  RETURN ReturnValue

Eventmgr_PrintSponsorList PROCEDURE                   !Generated from procedure template - Report

LocalRequest         LONG
FilesOpened          BYTE
Progress:Thermometer BYTE
Process:View         VIEW(Sponsor)
                       PROJECT(SPO:Address)
                       PROJECT(SPO:City)
                       PROJECT(SPO:CompanyName)
                       PROJECT(SPO:State)
                       PROJECT(SPO:Zip)
                       PROJECT(SPO:SponsorNumber)
                       JOIN(SPH:KeySponsorNumber,SPO:SponsorNumber)
                         PROJECT(SPH:Description)
                         PROJECT(SPH:PhoneNumber)
                       END
                     END
ProgressWindow       WINDOW('Report Progress...'),AT(,,142,59),CENTER,TIMER(1),GRAY,DOUBLE
                       PROGRESS,USE(Progress:Thermometer),AT(15,15,111,12),RANGE(0,100)
                       STRING(''),AT(0,3,141,10),USE(?Progress:UserString),CENTER
                       STRING(''),AT(0,30,141,10),USE(?Progress:PctText),CENTER
                       BUTTON('Cancel'),AT(45,42,50,15),USE(?Progress:Cancel)
                     END

report               REPORT('Event Manager-Event Sponsor List'),AT(1000,1719,6000,7281),PRE(RPT),FONT('Arial',10,,),THOUS
                       HEADER,AT(1000,1000,6000,677)
                         BOX,AT(10,10,5990,656),COLOR(COLOR:Black),FILL(COLOR:Silver)
                         STRING('Event Sponsor List'),AT(10,104,5990,490),TRN,CENTER,FONT('Arial',24,,FONT:bold)
                       END
break1                 BREAK(SPO:SponsorNumber)
                         HEADER,AT(0,0,6010,635)
                           BOX,AT(10,42,6000,583),USE(?Box2),COLOR(COLOR:Black)
                           LINE,AT(10,10,5990,0),USE(?Line2),COLOR(COLOR:Black),LINEWIDTH(5)
                           STRING(@S25),AT(10,63,1396,167),USE(SPO:CompanyName),TRN
                           STRING(@S25),AT(10,240,1396,167),USE(SPO:Address),TRN
                           STRING(@s2),AT(1469,427,271,167),USE(SPO:State),TRN
                           STRING(@S25),AT(21,427,1396,167),USE(SPO:City),TRN
                           STRING(@s10),AT(1688,427,969,167),USE(SPO:Zip),TRN,RIGHT(1)
                         END
detail                   DETAIL,AT(10,10,2438,271),USE(?detail)
                           STRING(@s10),AT(73,31),USE(SPH:Description)
                           STRING(@s20),AT(844,31),USE(SPH:PhoneNumber)
                         END
                       END
                       FOOTER,AT(1000,9000,6000,219)
                         STRING(@pPage <<<#p),AT(5250,31,698,135),PAGENO,USE(?PageCount),FONT('Arial',8,,FONT:regular)
                       END
                     END
ThisWindow           CLASS(ReportManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Reset                  PROCEDURE(BYTE Force=0),DERIVED
Update                 PROCEDURE(),DERIVED
                     END

ThisReport           CLASS(ProcessClass)              !Process Manager
TakeRecord             PROCEDURE(),BYTE,PROC,DERIVED
                     END

ProgressMgr          StepStringClass                  !Progress Manager
Previewer            PrintPreviewClass                !Print Previewer

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Eventmgr_PrintSponsorList')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Progress:Thermometer
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  Relate:Sponsor.Open
  SELF.FilesOpened = True
  OPEN(ProgressWindow)
  SELF.Opened=True
  INIMgr.Fetch('Eventmgr_PrintSponsorList',ProgressWindow)
  ProgressMgr.Init(ScrollSort:AllowAlpha+ScrollSort:AllowNumeric,ScrollBy:RunTime)
  ThisReport.Init(Process:View, Relate:Sponsor, ?Progress:PctText, Progress:Thermometer, ProgressMgr, SPO:CompanyName)
  ThisReport.CaseSensitiveValue = FALSE
  ThisReport.AddSortOrder(SPO:KeyCompanyName)
  SELF.AddItem(?Progress:Cancel,RequestCancelled)
  SELF.Init(ThisReport,report,Previewer)
  ?Progress:UserString{Prop:Text}=''
  Relate:Sponsor.SetQuickScan(1,Propagate:OneMany)
  Previewer.SetINIManager(INIMgr)
  Previewer.AllowUserZoom=True
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Sponsor.Close
  END
  IF SELF.Opened
    INIMgr.Update('Eventmgr_PrintSponsorList',ProgressWindow)
  END
  ProgressMgr.Kill()
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Reset PROCEDURE(BYTE Force=0)

  CODE
  SELF.ForcedReset += Force
  IF ProgressWindow{Prop:AcceptAll} THEN RETURN.
  SPH:SponsorNumber = SPO:SponsorNumber               ! Assign linking field value
  Access:SPhones.Fetch(SPH:KeySponsorNumber)
  PARENT.Reset(Force)


ThisWindow.Update PROCEDURE

  CODE
  PARENT.Update
  SPH:SponsorNumber = SPO:SponsorNumber               ! Assign linking field value
  Access:SPhones.Fetch(SPH:KeySponsorNumber)


ThisReport.TakeRecord PROCEDURE

ReturnValue          BYTE,AUTO

SkipDetails BYTE
  CODE
  ReturnValue = PARENT.TakeRecord()
  PRINT(RPT:detail)
  RETURN ReturnValue

