   PROGRAM



   INCLUDE('ABASCII.INC'),ONCE
   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABDROPS.INC'),ONCE
   INCLUDE('ABEIP.INC'),ONCE
   INCLUDE('ABERROR.INC'),ONCE
   INCLUDE('ABFILE.INC'),ONCE
   INCLUDE('ABFUZZY.INC'),ONCE
   INCLUDE('ABGRID.INC'),ONCE
   INCLUDE('ABPOPUP.INC'),ONCE
   INCLUDE('ABQUERY.INC'),ONCE
   INCLUDE('ABREPORT.INC'),ONCE
   INCLUDE('ABRESERV.INC'),ONCE
   INCLUDE('ABRESIZE.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABUTIL.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE
   INCLUDE('EQUATES.CLW'),ONCE
   INCLUDE('ERRORS.CLW'),ONCE
   INCLUDE('KEYCODES.CLW'),ONCE
   INCLUDE('MESSAG~1.INC'),ONCE
   INCLUDE('SBR_ED~1.INC'),ONCE
   INCLUDE('SBR_SE~1.INC'),ONCE
   INCLUDE('ABEXCEL.INC'),ONCE
   INCLUDE('ABOFFICE.INC'),ONCE
   INCLUDE('ABOUT.INC'),ONCE
   INCLUDE('ABWORD.INC'),ONCE
   INCLUDE('MO.INC'),ONCE
LPCSTR    EQUATE(CSTRING)

   MAP
     MODULE('EVENTBC.CLW')
DctInit     PROCEDURE
DctKill     PROCEDURE
     END
!--- Application Global and Exported Procedure Definitions --------------------------------------------
     MODULE('EVENT001.CLW')
Eventmgr_BrowseEvents  PROCEDURE   !*Browse the Events File
Eventmgr_BrowseVendors PROCEDURE   !*Browse Vendors
     END
     MODULE('EVENT002.CLW')
Eventmgr_Main          PROCEDURE   !Event Manager Frame
Eventmgr_BrowseMembers PROCEDURE   !*Browse the Members File
Eventmgr_BrowseSponsors PROCEDURE   !*Browse the Sponsor File
Eventmgr_Preferences   PROCEDURE(BYTE)   !*Save Default Settings in INI file
     END
     MODULE('EVENT003.CLW')
Eventmgr_HelpAbout     PROCEDURE   !*About This Program
Eventmgr_PrintEventInvoice PROCEDURE   !*Print Event Invoice
Eventmgr_PrintTableSeatingList PROCEDURE   !*Report the Attendees File
Eventmgr_PrintEventSummary PROCEDURE   !*Print Event Summary
Eventmgr_PrintMemberLabels PROCEDURE   !Print Member mailing Labels
Eventmgr_PrintMemberList PROCEDURE   !Print Member List by Name
Eventmgr_PrintNameBadges PROCEDURE   !Print Name Badges for an Event
Eventmgr_PrintPlaceCards PROCEDURE   !Print Place Cards for an Event
Eventmgr_PrintSponsorLabels PROCEDURE   !Print Sponsor Mailing Labels
Eventmgr_PrintSponsorList PROCEDURE   !Print Sponsor List by Company Name
     END
     MODULE('EVENT004.CLW')
Eventmgr_PrintVendorLabels PROCEDURE   !Print Vendor Mailing Labels
Eventmgr_PrintVendorList PROCEDURE   !Print Vendor Phone List
Eventmgr_SplashScreen  PROCEDURE   !*Welcome Splash Screen*
     END
     MODULE('WINAPI')
     !!Prototype to play sound (requires equate for LPCSTR data type in After Global includes)
       OMIT('***',_WIDTH32_)
         sndPlaySound(*LPCSTR,UNSIGNED),BOOL,PROC,pascal,raw
                  ***
       COMPILE('***',_WIDTH32_)
        sndPlaySound(*LPCSTR,UNSIGNED),BOOL,PROC,pascal,raw,NAME('sndPlaySoundA')
            ***
     END
Eventmgr:Init PROCEDURE(<ErrorClass curGlobalErrors>, <INIClass curINIMgr>)
Eventmgr:Kill PROCEDURE
   END

DefaultSoundEnable BYTE(1)
DefaultCity        STRING(20)
DefaultState       STRING(2)
DefaultZIP         STRING(10)
DefaultMaxTables   BYTE
DefaultSeatsPerTable BYTE
GLO:Running:BrowseEvents LONG(0)
GLO:Running:Assigntables LONG(0)
GLO:Running:ShowMemberToolBox LONG(0)
GLO:AppFrameThread LONG(0)
GLO:Running:BrowseMembers LONG(0)
GLO:Running:BrowseVendors LONG(0)
GLO:Running:BrowseSponsors LONG(0)
GLO:MemberButton   LONG
GLO:VendorButton   LONG
GLO:EventButton    LONG
GLO:SponsorButton  LONG
GLO:AttendeeList   LONG
GLO:StartColor     BYTE
SilentRunning        BYTE(0)                         !Set true when application is running in silent mode

Events               FILE,DRIVER('TOPSPEED'),NAME('E_Events.tps'),PRE(EVE),CREATE,BINDABLE,THREAD
KeyNumber                KEY(EVE:Number),NOCASE,OPT,PRIMARY
KeyDescription           KEY(EVE:Description,-EVE:Date),DUP,NOCASE
KeyDate                  KEY(-EVE:Date),DUP,NOCASE
KeySponsor               KEY(-EVE:Sponsor,EVE:Date),DUP,NOCASE,OPT
Notes                       MEMO(1000)
Record                   RECORD,PRE()
Number                      LONG
Description                 STRING(40)
Date                        LONG
Sponsor                     DECIMAL(4)
MaxTables                   BYTE
SeatsPerTable               BYTE
                         END
                     END                       

LineItems            FILE,DRIVER('TOPSPEED'),NAME('E_LineItem.tps'),PRE(LIN),CREATE,BINDABLE,THREAD
KeyLineNumber            KEY(LIN:EventNumber,LIN:LineNumber),NOCASE,OPT,PRIMARY
KeyEventNumber           KEY(LIN:EventNumber),DUP,NOCASE
KeyItemType              KEY(LIN:EventNumber,LIN:ItemTypeCode,LIN:LineNumber),DUP,NOCASE
VendorKey                KEY(LIN:Vendor),DUP,NOCASE,OPT
KeyTypeCode              KEY(LIN:ItemTypeCode),DUP,NOCASE,OPT
Notes                       MEMO(1000)
Record                   RECORD,PRE()
LineNumber                  LONG
EventNumber                 LONG
ItemTypeCode                STRING(10)
Quantity                    LONG
Description                 STRING(40)
Vendor                      LONG
BudgetCost                  DECIMAL(6,2)
ActualCost                  DECIMAL(6,2)
BillPrice                   DECIMAL(6,2)
                         END
                     END                       

Vendor               FILE,DRIVER('TOPSPEED'),NAME('E_Vendor.tps'),PRE(VEN),CREATE,BINDABLE,THREAD
KeyVendorNumber          KEY(VEN:VendorNumber),NOCASE,OPT,PRIMARY
KeyZip                   KEY(VEN:Zip),DUP,NOCASE
KeyCompanyName           KEY(VEN:CompanyName),DUP,NOCASE,OPT
Record                   RECORD,PRE()
VendorNumber                LONG
CompanyName                 STRING(25)
Address                     STRING(40)
Address2                    STRING(40)
City                        STRING(25)
State                       STRING(2)
Zip                         STRING(10)
                         END
                     END                       

Sponsor              FILE,DRIVER('TOPSPEED'),NAME('E_Sponsor.tps'),PRE(SPO),CREATE,BINDABLE,THREAD
KeySponsorNumber         KEY(SPO:SponsorNumber),NOCASE,OPT,PRIMARY
KeyZip                   KEY(SPO:Zip),DUP,NOCASE
KeyCompanyName           KEY(SPO:CompanyName),DUP,NOCASE,OPT
Record                   RECORD,PRE()
SponsorNumber               LONG
CompanyName                 STRING(25)
Address                     STRING(40)
Address2                    STRING(40)
City                        STRING(25)
State                       STRING(2)
Zip                         STRING(10)
                         END
                     END                       

Attendees            FILE,DRIVER('TOPSPEED'),NAME('E_Attendee.tps'),PRE(ATT),CREATE,BINDABLE,THREAD
KeyEventTableAttendee    KEY(ATT:EventNumber,ATT:TableNumber,ATT:Attendee),NOCASE,PRIMARY
KeyAttendees             KEY(ATT:Attendee),DUP,NOCASE
KeyEventAttendee         KEY(ATT:EventNumber,ATT:Attendee),NOCASE,OPT
Record                   RECORD,PRE()
EventNumber                 LONG
TableNumber                 BYTE
Attendee                    LONG
                         END
                     END                       

Members              FILE,DRIVER('TOPSPEED'),NAME('E_Members.tps'),PRE(MEM),CREATE,BINDABLE,THREAD
MemberNumberKey          KEY(MEM:MemberNumber),NOCASE,OPT,PRIMARY
NameKey                  KEY(MEM:LastName,MEM:FirstName),DUP,NOCASE
ZipCodeKey               KEY(MEM:ZIPCode),DUP,NOCASE
Record                   RECORD,PRE()
MemberNumber                LONG
LastName                    STRING(25)
FirstName                   STRING(20)
MiddleName                  STRING(1)
Address                     STRING(40)
Address2                    STRING(40)
City                        STRING(25)
State                       STRING(2)
ZIPCode                     STRING(10)
DateJoin                    LONG
Active                      BYTE
MemberType                  STRING(15)
                         END
                     END                       

VendorType           FILE,DRIVER('TOPSPEED'),NAME('E_VendorTy.tps'),PRE(TYP),BINDABLE,CREATE,THREAD
KeyTypeCode              KEY(TYP:TypeCode),NOCASE,OPT
Record                   RECORD,PRE()
TypeCode                    STRING(10)
                         END
                     END                       

MemberType           FILE,DRIVER('TOPSPEED'),NAME('E_MemberTy.tps'),PRE(MTY),BINDABLE,CREATE,THREAD
KeyTypeCode              KEY(MTY:TypeCode),NOCASE,OPT
Record                   RECORD,PRE()
TypeCode                    STRING(15)
                         END
                     END                       

MPhones              FILE,DRIVER('TOPSPEED'),NAME('E_Mphones.tps'),PRE(MPH),CREATE,BINDABLE,THREAD
KeyMemberNumber          KEY(MPH:MemberNumber),DUP,NOCASE,OPT
Record                   RECORD,PRE()
MemberNumber                LONG
Description                 STRING(10)
PhoneNumber                 STRING(20)
                         END
                     END                       

VPhones              FILE,DRIVER('TOPSPEED'),NAME('E_VPhones.tps'),PRE(VPH),CREATE,BINDABLE,THREAD
KeyVendorNumber          KEY(VPH:VendorNumber),DUP,NOCASE,OPT
Record                   RECORD,PRE()
VendorNumber                LONG
Description                 STRING(10)
PhoneNumber                 STRING(20)
                         END
                     END                       

SPhones              FILE,DRIVER('TOPSPEED'),NAME('E_SPhones.tps'),PRE(SPH),CREATE,BINDABLE,THREAD
KeySponsorNumber         KEY(SPH:SponsorNumber),DUP,NOCASE,OPT
Record                   RECORD,PRE()
SponsorNumber               LONG
Description                 STRING(10)
PhoneNumber                 STRING(20)
                         END
                     END                       

States               FILE,DRIVER('TOPSPEED'),NAME('E_States.tps'),PRE(ST),CREATE,BINDABLE,THREAD
StateKey                 KEY(ST:StateCode),NOCASE,OPT,PRIMARY
Record                   RECORD,PRE()
StateCode                   STRING(2)
StateName                   STRING(20)
                         END
                     END                       



Access:Events        &FileManager
Relate:Events        &RelationManager
Access:LineItems     &FileManager
Relate:LineItems     &RelationManager
Access:Vendor        &FileManager
Relate:Vendor        &RelationManager
Access:Sponsor       &FileManager
Relate:Sponsor       &RelationManager
Access:Attendees     &FileManager
Relate:Attendees     &RelationManager
Access:Members       &FileManager
Relate:Members       &RelationManager
Access:VendorType    &FileManager
Relate:VendorType    &RelationManager
Access:MemberType    &FileManager
Relate:MemberType    &RelationManager
Access:MPhones       &FileManager
Relate:MPhones       &RelationManager
Access:VPhones       &FileManager
Relate:VPhones       &RelationManager
Access:SPhones       &FileManager
Relate:SPhones       &RelationManager
Access:States        &FileManager
Relate:States        &RelationManager
GlobalRequest        BYTE(0),THREAD
GlobalResponse       BYTE(0),THREAD
VCRRequest           LONG(0),THREAD
FuzzyMatcher         FuzzyClass
LocalErrors          ErrorClass
LocalINIMgr          INIClass
GlobalErrors         &ErrorClass
INIMgr               &INIClass
DLLInitializer       CLASS                              !This object is used to trigger initialization of the dll
Construct              PROCEDURE
Destruct               PROCEDURE
                     END

  CODE
    PRAGMA('define(init_priority=>3)')
DLLInitializer.Construct PROCEDURE

  CODE
  LocalErrors.Init
  LocalINIMgr.Init('Eventmgr.INI')
  GlobalErrors &= LocalErrors
  INIMgr &= LocalINIMgr
  DctInit
  FuzzyMatcher.Init
  FuzzyMatcher.SetOption(MatchOption:NoCase, 1)
  FuzzyMatcher.SetOption(MatchOption:WordOnly, 0)
  
!These procedures are used to initialize the DLL. It must be called by the main executable when it starts up
Eventmgr:Init PROCEDURE(<ErrorClass curGlobalErrors>, <INIClass curINIMgr>)

  CODE
  IF ~curGlobalErrors &= NULL
    GlobalErrors &= curGlobalErrors
  END
  IF ~curINIMgr &= NULL
    INIMgr &= curINIMgr
  END


!This procedure is used to shutdown the DLL. It must be called by the main executable before it closes down

Eventmgr:Kill PROCEDURE

  CODE

  


DLLInitializer.Destruct PROCEDURE

  CODE
  FuzzyMatcher.Kill
  DctKill
  LocalINIMgr.Kill
  LocalErrors.Kill



