

   MEMBER('Frame.clw')                                ! This is a MEMBER module


   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('FRAME001.INC'),ONCE        !Local module procedure declarations
                     END


Main PROCEDURE                                        !Generated from procedure template - Frame

SplashProcedureThread LONG
AppFrame             APPLICATION('Frame Application [ Event Manager + Mail List Manager ]'),AT(,,400,240),FONT('MS Sans Serif',8,,),STATUS(-1,80,120,45),SYSTEM,MAX,MAXIMIZE,RESIZE,IMM
                       MENUBAR,USE(?Menubar)
                         MENU('&File'),USE(?FileMenu)
                           ITEM('&Print Setup ...'),USE(?PrintSetup),MSG('Setup printer'),STD(STD:PrintSetup)
                           ITEM,SEPARATOR
                           ITEM('Event Manager Preferences'),USE(?Browse1EventManagerEventManagerPreferences)
                           ITEM,SEPARATOR
                           ITEM('E&xit'),USE(?Exit),MSG('Exit this application'),STD(STD:Close)
                         END
                         MENU('&Edit'),USE(?EditMenu)
                           ITEM('Cu&t'),USE(?Cut),MSG('Remove item to Windows Clipboard'),STD(STD:Cut)
                           ITEM('&Copy'),USE(?Copy),MSG('Copy item to Windows Clipboard'),STD(STD:Copy)
                           ITEM('&Paste'),USE(?Paste),MSG('Paste contents of Windows Clipboard'),STD(STD:Paste)
                         END
                         MENU('&Browse'),USE(?Browse)
                           MENU('&1) Event Manager'),USE(?Browse1EventManager)
                             ITEM,SEPARATOR
                             ITEM('Browse Events'),USE(?Browse1EventManagerBrowseEvents)
                             ITEM('Browse Members'),USE(?Browse1EventManagerBrowseMembers)
                             ITEM('Browse Sponsors'),USE(?Browse1EventManagerBrowseSponsors)
                             ITEM('Browse Vendors'),USE(?Browse1EventManagerBrowseVendors)
                           END
                           MENU('&2) Mail List Manager'),USE(?Browse2ListManager)
                             ITEM('Browse Keywords'),USE(?Browse2MailListManagerBrowseKeywords)
                             ITEM('Browse Mailers'),USE(?Browse2MailListManagerBrowseMailers)
                             ITEM('Browse People'),USE(?Browse2MailListManagerBrowsePeople)
                             ITEM('Browse State File'),USE(?Browse2MailListManagerBrowseStateFile)
                           END
                         END
                         MENU('&Reports'),USE(?Reports)
                           MENU('&3) Event Manager'),USE(?Reports3EventManager)
                             ITEM('Print Event Invoice'),USE(?Reports3EventManagerPrintEventInvoice)
                           END
                           MENU('&4) Mail List Manager'),USE(?Reports4MailListManager)
                             ITEM('Report Mailing List'),USE(?Reports4MailListManagerReportMailingList)
                           END
                         END
                         MENU('&Window'),USE(?WindowMenu),MSG('Create and Arrange windows'),STD(STD:WindowList)
                           ITEM('T&ile'),USE(?Tile),MSG('Make all open windows visible'),STD(STD:TileWindow)
                           ITEM('&Cascade'),USE(?Cascade),MSG('Stack all open windows'),STD(STD:CascadeWindow)
                           ITEM('&Arrange Icons'),USE(?Arrange),MSG('Align all window icons'),STD(STD:ArrangeIcons)
                         END
                         MENU('&Help'),USE(?HelpMenu),MSG('Windows Help')
                           ITEM('&Contents'),USE(?Helpindex),MSG('View the contents of the help file'),STD(STD:HelpIndex)
                           ITEM('&Search for Help On...'),USE(?HelpSearch),MSG('Search for help on a subject'),STD(STD:HelpSearch)
                           ITEM('&How to Use Help'),USE(?HelpOnHelp),MSG('How to use Windows Help'),STD(STD:HelpOnHelp)
                           ITEM,SEPARATOR
                           ITEM('About Event Manager...'),USE(?HelpAboutEventManager)
                           ITEM('About Mail List Manager...'),USE(?HelpAboutMailListManager)
                         END
                       END
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
TakeWindowEvent        PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass

  CODE
  GlobalResponse = ThisWindow.Run()

Menu::FileMenu ROUTINE                                !Code for menu items on ?FileMenu
  CASE ACCEPTED()
  OF ?Browse1EventManagerEventManagerPreferences
    Eventmgr_Preferences(FALSE)
  END
Menu::EditMenu ROUTINE                                !Code for menu items on ?EditMenu
Menu::Browse ROUTINE                                  !Code for menu items on ?Browse
Menu::Browse1EventManager ROUTINE                     !Code for menu items on ?Browse1EventManager
  CASE ACCEPTED()
  OF ?Browse1EventManagerBrowseEvents
    START(Eventmgr_BrowseEvents, 25000)
  OF ?Browse1EventManagerBrowseMembers
    START(Eventmgr_BrowseMembers, 25000)
  OF ?Browse1EventManagerBrowseSponsors
    START(Eventmgr_BrowseSponsors, 25000)
  OF ?Browse1EventManagerBrowseVendors
    START(Eventmgr_BrowseVendors, 25000)
  END
Menu::Browse2ListManager ROUTINE                      !Code for menu items on ?Browse2ListManager
  CASE ACCEPTED()
  OF ?Browse2MailListManagerBrowseKeywords
    START(MailList_BrowseKeywords, 25000)
  OF ?Browse2MailListManagerBrowseMailers
    START(MailList_BrowseMailers, 25000)
  OF ?Browse2MailListManagerBrowsePeople
    START(MailList_BrowsePeople, 25000)
  OF ?Browse2MailListManagerBrowseStateFile
    START(MailList_BrowseStateFile, 25000)
  END
Menu::Reports ROUTINE                                 !Code for menu items on ?Reports
Menu::Reports3EventManager ROUTINE                    !Code for menu items on ?Reports3EventManager
  CASE ACCEPTED()
  OF ?Reports3EventManagerPrintEventInvoice
    START(Eventmgr_PrintEventInvoice, 25000)
  END
Menu::Reports4MailListManager ROUTINE                 !Code for menu items on ?Reports4MailListManager
  CASE ACCEPTED()
  OF ?Reports4MailListManagerReportMailingList
    START(MailList_ReportMailingList, 25000)
  END
Menu::WindowMenu ROUTINE                              !Code for menu items on ?WindowMenu
Menu::HelpMenu ROUTINE                                !Code for menu items on ?HelpMenu
  CASE ACCEPTED()
  OF ?HelpAboutEventManager
    START(Eventmgr_HelpAbout, 25000)
  OF ?HelpAboutMailListManager
    START(MailList_WindowAbout, 25000)
  END

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Main')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = 1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  OPEN(AppFrame)
  SELF.Opened=True
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE ACCEPTED()
    ELSE
      DO Menu::FileMenu                               !Process menu items on ?FileMenu menu
      DO Menu::EditMenu                               !Process menu items on ?EditMenu menu
      DO Menu::Browse                                 !Process menu items on ?Browse menu
      DO Menu::Browse1EventManager                    !Process menu items on ?Browse1EventManager menu
      DO Menu::Browse2ListManager                     !Process menu items on ?Browse2ListManager menu
      DO Menu::Reports                                !Process menu items on ?Reports menu
      DO Menu::Reports3EventManager                   !Process menu items on ?Reports3EventManager menu
      DO Menu::Reports4MailListManager                !Process menu items on ?Reports4MailListManager menu
      DO Menu::WindowMenu                             !Process menu items on ?WindowMenu menu
      DO Menu::HelpMenu                               !Process menu items on ?HelpMenu menu
    END
  ReturnValue = PARENT.TakeAccepted()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeWindowEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeWindowEvent()
    CASE EVENT()
    OF EVENT:OpenWindow
      SplashProcedureThread = START(Eventmgr_SplashScreen)
    ELSE
      IF SplashProcedureThread
        IF EVENT() = Event:Accepted
          POST(Event:CloseWindow,,SplashProcedureThread)
          SplashPRocedureThread = 0
        END
     END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

